// pbN} for PIC32MX370F512H@by K.Tanaka
// TGvideo370fLib.X.agp
// 300~225hbgA256F
// 36~28LN^[
// SDJ[hu[g[_[Ή

#include <plib.h>
#include "TGvideo370f.h"
#include "pacman370f.h"
#ifdef BOOTLOADER
#include "recscore.h"
#endif

//OtNX^ with PLL (20/3{)
//NX^3.579545~414.31818MHz
#pragma config FSRSSEL = PRIORITY_7
#pragma config PMDL1WAY = OFF
#pragma config IOL1WAY = OFF
//#pragma config FUSBIDIO = OFF
//#pragma config FVBUSONIO = OFF
#pragma config FPLLIDIV = DIV_3
#pragma config FPLLMUL = MUL_20
//#pragma config UPLLIDIV = DIV_1
//#pragma config UPLLEN = OFF
#pragma config FPLLODIV = DIV_1
#pragma config FNOSC = PRIPLL
#pragma config FSOSCEN = OFF
#pragma config IESO = OFF
#pragma config POSCMOD = XT
#pragma config OSCIOFNC = OFF
#pragma config FPBDIV = DIV_1
#pragma config FCKSM = CSDCMD
#pragma config FWDTEN = OFF
#pragma config DEBUG = OFF
#pragma config PWP = OFF
#pragma config BWP = OFF
#pragma config CP = OFF

_Character pacman,akabei,pinky,aosuke,guzuta; //eLN^[̍\
_Music music; //t̉y\
unsigned int score,highscore; //_AnCXRA
unsigned char player; //pbN}c
unsigned char stage; //݂̃Xe[W
unsigned char gamecount; //S̃JE^[
unsigned char gamestatus; //0:Q[X^[gA1:Q[A2:vC[1A3:Xe[WNAA4:Q[I[o[
unsigned short pacmanspeed,monsterspeed,ijikespeed,medamaspeed;//݂̃Xe[W̊eL̈ړxiJE^j
unsigned short ijiketime; //݂̃Xe[W̃CWP
unsigned char fruitno; //݂̃Xe[W̃t[cԍ
unsigned char upflag; //10000_z̃vC[`FbN
unsigned char fruitflag1,fruitflag2; //݂̃Xe[WŃt[cõtO
unsigned short fruitcount; //t[c\ԃJE^[
unsigned char cookie; //c
unsigned char huntedmonster; //CWP߂܂i_vZpj
unsigned short monsterhuntedtimer; //CWP߂܂ĂԂ̒~JE^[
unsigned short fruitscoretimer; //t[cl̓_\JE^[
unsigned char monstersoundcount; //X^[ʉ
unsigned char cookiesoundcount,fruitsoundcount,over10000soundcount;//eʉ̎
unsigned short monstersound,monstersounddif; //X^[ʉ̒lƑli[hɂقȂj
unsigned short monsterhuntedsound; //CWPߊlʉ̒l
unsigned short fruitsound; //t[clʉ
unsigned short firekeyold; //ꎞ~L[
unsigned char map[MAPXSIZE*MAPYSIZE]; // ʘHAǁAAp[At[cAhA邱Ƃ\
unsigned char fruit[]={0,1,2,2,3,3,4,4,5,5,6,6,7}; //ʂƂ̃t[cԍ
unsigned short fruitscore[]={10,30,50,70,100,200,300,500}; //t[c̓_
unsigned short pacmansp[]= {135,150,150,150,160,160,160,170,170,170,190,190,190,210,210,210,210,256,256,256,256}; //ʂƂ̃pbN}x
unsigned short monstersp[]={135,150,150,150,160,160,160,170,170,170,190,190,190,210,210,210,210,256,256,256,256}; //ʂƂ̃X^[x
unsigned short ijikesp[]=  { 50, 60, 60, 60, 65, 65, 65, 70, 70, 70, 75, 75, 75, 80, 80, 80, 80, 90, 90, 90, 90}; //ʂƂ̃CWPx
unsigned short ijike[]=    {550,520,450,350,130,300,130,120, 60,300,100, 60, 60,180, 60, 60,  0 ,60,  0,  0,  0}; //ʂƂ̃CWP
unsigned short medamasp[]= {512,512,512,512,512,512,512,512,512,512,512,512,512,512,512,512,512,512,512,512,512}; //ʂƂ̖ڋʑx

//sounddataz@h?̃h?̏̃h̎JE^lAPR3ɏނƉݒ肳
unsigned short sounddata[]={22803,21523,20315,19175,18098,17083,16124,15219,14365,13558,12797,12079,
				11401,10761,10157,9587,9049,8541,8062,7609,7182,6779,6398,6039,
				5700};
//musicdataz@K,,K,,EEEEE@ŌɉK254ŋȏI
//				K@0:h?12:̃h?24:̏̃h@@255:x
//				@60nb
unsigned char musicdata1[]={0,3,12,5,19,8,16,8,0,3,12,8,0,3,19,5,16,8,12,8,255,8,
						1,3,13,5,20,8,17,8,1,3,13,8,1,3,20,5,17,8,13,8,255,8,
						0,3,12,5,19,8,16,8,0,3,12,8,0,3,19,5,16,8,12,8,255,8,
						7,3,17,5,18,8,9,3,19,5,20,8,11,3,21,5,23,8,12,3,24,5,254};
unsigned char musicdata2[]={6,6,255,2,6,6,255,2,6,8,3,4,1,4,6,2,255,2,6,12,10,16,
						6,6,255,2,6,6,255,2,6,8,3,4,1,4,6,2,255,2,6,12,3,16,
						6,6,255,2,6,6,255,2,6,8,3,4,1,4,6,2,255,2,6,12,9,8,11,8,
						12,8,11,8,9,8,6,8,9,8,6,16,255,8,
						6,6,255,2,6,6,255,2,6,8,3,4,1,4,6,2,255,2,6,12,10,16,
						6,6,255,2,6,6,255,2,6,8,3,4,1,4,6,2,255,2,6,12,3,16,
						6,6,255,2,6,6,255,2,6,8,3,4,1,4,6,2,255,2,6,12,9,8,11,8,
						12,8,11,8,9,8,6,8,9,8,6,16,254};
//
//}bv`
unsigned char scenedata[MAPXSIZE*MAPYSIZE]={
	//ǂƂ̔zu 0x80?0x8e:ǁA0x8f:ȂiʘHjA0x90:A0x91:p[
	0x80,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x8a,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x81,
	0x85,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x85,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x85,
	0x85,0x90,0x80,0x84,0x81,0x90,0x80,0x84,0x81,0x90,0x85,0x90,0x80,0x84,0x81,0x90,0x80,0x84,0x81,0x90,0x85,
	0x85,0x91,0x85,0x8f,0x85,0x90,0x85,0x8f,0x85,0x90,0x85,0x90,0x85,0x8f,0x85,0x90,0x85,0x8f,0x85,0x91,0x85,
	0x85,0x90,0x82,0x84,0x83,0x90,0x82,0x84,0x83,0x90,0x86,0x90,0x82,0x84,0x83,0x90,0x82,0x84,0x83,0x90,0x85,
	0x85,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x85,
	0x85,0x90,0x80,0x84,0x81,0x90,0x87,0x90,0x80,0x84,0x84,0x84,0x81,0x90,0x87,0x90,0x80,0x84,0x81,0x90,0x85,
	0x85,0x90,0x82,0x84,0x83,0x90,0x85,0x90,0x82,0x84,0x8a,0x84,0x83,0x90,0x85,0x90,0x82,0x84,0x83,0x90,0x85,
	0x85,0x90,0x90,0x90,0x90,0x90,0x85,0x90,0x90,0x90,0x85,0x90,0x90,0x90,0x85,0x90,0x90,0x90,0x90,0x90,0x85,
	0x82,0x84,0x84,0x84,0x81,0x90,0x8d,0x84,0x89,0x90,0x86,0x90,0x88,0x84,0x8c,0x90,0x80,0x84,0x84,0x84,0x83,
	0x8f,0x8f,0x8f,0x8f,0x85,0x90,0x85,0x8f,0x8f,0x8f,0x8f,0x8f,0x8f,0x8f,0x85,0x90,0x85,0x8f,0x8f,0x8f,0x8f,
	0x8f,0x8f,0x8f,0x8f,0x85,0x90,0x85,0x8f,0x80,0x84,0x8e,0x84,0x81,0x8f,0x85,0x90,0x85,0x8f,0x8f,0x8f,0x8f,
	0x88,0x84,0x84,0x84,0x83,0x90,0x86,0x8f,0x85,0x8f,0x8f,0x8f,0x85,0x8f,0x86,0x90,0x82,0x84,0x84,0x84,0x89,
	0x8f,0x8f,0x8f,0x8f,0x8f,0x90,0x8f,0x8f,0x85,0x8f,0x8f,0x8f,0x85,0x8f,0x8f,0x90,0x8f,0x8f,0x8f,0x8f,0x8f,
	0x88,0x84,0x84,0x84,0x81,0x90,0x87,0x8f,0x82,0x84,0x84,0x84,0x83,0x8f,0x87,0x90,0x80,0x84,0x84,0x84,0x89,
	0x8f,0x8f,0x8f,0x8f,0x85,0x90,0x85,0x8f,0x8f,0x8f,0x8f,0x8f,0x8f,0x8f,0x85,0x90,0x85,0x8f,0x8f,0x8f,0x8f,
	0x8f,0x8f,0x8f,0x8f,0x85,0x90,0x85,0x8f,0x80,0x84,0x84,0x84,0x81,0x8f,0x85,0x90,0x85,0x8f,0x8f,0x8f,0x8f,
	0x80,0x84,0x84,0x84,0x83,0x90,0x86,0x8f,0x82,0x84,0x8a,0x84,0x83,0x8f,0x86,0x90,0x82,0x84,0x84,0x84,0x81,
	0x85,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x85,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x85,
	0x85,0x90,0x88,0x84,0x81,0x90,0x88,0x84,0x89,0x90,0x86,0x90,0x88,0x84,0x89,0x90,0x80,0x84,0x89,0x90,0x85,
	0x85,0x91,0x90,0x90,0x85,0x90,0x90,0x90,0x90,0x90,0x8f,0x90,0x90,0x90,0x90,0x90,0x85,0x90,0x90,0x91,0x85,
	0x8d,0x84,0x81,0x90,0x85,0x90,0x87,0x90,0x80,0x84,0x84,0x84,0x81,0x90,0x87,0x90,0x85,0x90,0x80,0x84,0x8c,
	0x8d,0x84,0x83,0x90,0x86,0x90,0x85,0x90,0x82,0x84,0x8a,0x84,0x83,0x90,0x85,0x90,0x86,0x90,0x82,0x84,0x8c,
	0x85,0x90,0x90,0x90,0x90,0x90,0x85,0x90,0x90,0x90,0x85,0x90,0x90,0x90,0x85,0x90,0x90,0x90,0x90,0x90,0x85,
	0x85,0x90,0x88,0x84,0x84,0x84,0x8b,0x84,0x89,0x90,0x86,0x90,0x88,0x84,0x8b,0x84,0x84,0x84,0x89,0x90,0x85,
	0x85,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x85,
	0x82,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x83
};

//}Nݒ@z}bv̓ǂݏoA
#define GETMAP(x,y) map[(y)*MAPXSIZE+(x)]
#define SETMAP(x,y,d) map[(y)*MAPXSIZE+(x)]=(d)

void wait60thsec(unsigned short n){
	// 60nbEFCgirfIʂ̍ŉsMo͏I܂ő҂j
	drawcount=0;
	while(drawcount<n) asm("wait");
}
unsigned char startkeycheck(unsigned short n){
	// 60nbEFCg
	// X^[g{^΂߂
	//@߂l@X^[g{^1AȂ0
	drawcount=0;
	while(drawcount<n){
		if(~KEYPORT & KEYSTART) return 1;
		asm("wait");
	}
	return 0;
}
void playmusic60thsec(void){
	//601bEFCgA݉t̋Ȃ1i߂
	wait60thsec(1); //601bEFCg
	if(music.stop) return; //tIς
	music.count--;
	if(music.count>0) return;

	//̉炷
	if(*music.p==254){ //ȏI
		music.stop=1;
		PR3=0;
		return;
	}
	if(*music.p==255) PR3=0; //x
	else PR3=sounddata[*music.p]; //f[^
	music.p++;
	music.count=*music.p; //
	music.p++;
}
void startmusic(unsigned char *m){
	music.p=m;
	music.count=1;
	music.stop=0;
}
/*
//@Pɋȉt@i͖gpj
void playmusic(unsigned char *m){
	startmusic(m);
	while(music.stop==0){
		playmusic60thsec();
	}
}
*/

// m*cnhbg̃LN^[Wx,yɕ\
// unsigned char bmp[m*n]zɁAPɃJ[ԍׂ
// J[ԍ0͓̕FƂĈ
void putbmpmn_map(int x,int y,char m,char n,const unsigned char bmp[])
{// Q[̃}bvɕ`̏ꍇ͂i}bvOɂ͂ݏo͕\Ȃj
	int i,j;
	unsigned char *vp;
	const unsigned char *p;
	if(x<=-m || x>=MAPXSIZE*8 || y<=-n || y>=MAPYSIZE*8) return; //ʊO
	if(y<0){ //ʏ㕔ɐ؂ꍇ
		i=0;
		p=bmp-y*m;
	}
	else{
		i=y;
		p=bmp;
	}
	for(;i<y+n;i++){
		if(i>=MAPYSIZE*8) return; //ʉɐ؂ꍇ
		if(x<0){ //ʍɐ؂ꍇ͎c镔̂ݕ`
			j=0;
			p+=-x;
			vp=VRAM+i*X_RES;
		}
		else{
			j=x;
			vp=VRAM+i*X_RES+x;
		}
		for(;j<x+m;j++){
			if(j>=MAPXSIZE*8){ //ʉEɐ؂ꍇ
				p+=x+m-j;
				break;
			}
			if(*p!=0){ //J[ԍ0̏ꍇAƂď
				*vp=*p;
			}
			p++;
			vp++;
		}
	}
}

void putpacman(void){
	//pbN}̕\
	unsigned char a;
	pacman.animcount--;
	if(pacman.animcount==0){
		pacman.animcount=pacman.animcount0;
		pacman.animvalue++;
		if(pacman.animvalue==6) pacman.animvalue=0;
	}
	if(pacman.animvalue==0) a=0;
	else if(pacman.animvalue<=3) a=pacman.dir*3+pacman.animvalue;
	else a=pacman.dir*3+6-pacman.animvalue;
	putbmpmn_map((int)(pacman.x/256)-3,(int)(pacman.y/256)-3,XWIDTH_PACMAN,YWIDTH_PACMAN,Pacmanbmp[a]);
}
void putmonster(_Character *p){
	//X^[\@p:LN^[̃|C^w
	unsigned char i;//X^[̑̃p^[i2ށj
	if(gamecount & 4) i=0;
	else i=1;
	switch(p->status){
		case IJIKE:
			if(p->modecount>180 || gamecount & 8)
				putbmpmn_map((int)(p->x/256)-3,(int)(p->y/256)-3,XWIDTH_MONSTER,YWIDTH_MONSTER,Ijikebmp[i]);
			else
				//œ_
				putbmpmn_map((int)(p->x/256)-3,(int)(p->y/256)-3,XWIDTH_MONSTER,YWIDTH_MONSTER,Ijikebmp[2+i]);
			break;
		case MEDAMA:
			putbmpmn_map((int)(p->x/256)-3,(int)(p->y/256)-3,XWIDTH_MONSTER,YWIDTH_MONSTER,Medamabmp[p->dir]);
			break;
		default:
			putbmpmn_map((int)(p->x/256)-3,(int)(p->y/256)-3,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[p->no*8+p->dir*2+i]);
	}
}
void blinkpowercookie(){
	//p[̓_
	if(gamecount & 0x10){
		set_palette(COLOR_POWERCOOKIE,0,50,50);
	}
	else{
		set_palette(COLOR_POWERCOOKIE,0,255,255);
	}
}
unsigned char getfruitno(unsigned char s){
	// sʂ̃t[cԍԂ
	if(s<13) return fruit[s-1];
	else return fruit[12];
}
void putfruit(void){
	// t[c\
	putbmpmn_map(FRUITX*8-2,FRUITY*8-3,12,14,Fruitbmp[fruitno]);
}
void putmapchar(unsigned char x,unsigned char y){
	//}bṽR[hɉ̂\
	unsigned char d;

	d=GETMAP(x,y);
	if(d==MAP_COOKIE) gputfont(x*8,y*8,COLOR_COOKIE,0,CODE_COOKIE);
	else if(d==MAP_POWERCOOKIE) gputfont(x*8,y*8,COLOR_POWERCOOKIE,0,CODE_POWERCOOKIE);
	else if(d==MAP_DOOR) gputfont(x*8,y*8,COLOR_DOOR,0,CODE_DOOR);
	else if(d==MAP_WALL) gputfont(x*8,y*8,COLOR_WALL,0,scenedata[y*MAPXSIZE+x]);
	else gputfont(x*8,y*8,0,0,' ');
}
void setfruit(unsigned char f){
	// f 0:t[c폜&\A1:t[c&\
	if(f){
		SETMAP(FRUITX,FRUITY,MAP_FRUIT);
	}
	else{
		SETMAP(FRUITX,FRUITY,MAP_NONE);
		putmapchar(FRUITX-1,FRUITY-1);
		putmapchar(FRUITX  ,FRUITY-1);
		putmapchar(FRUITX+1,FRUITY-1);
		putmapchar(FRUITX-1,FRUITY  );
		putmapchar(FRUITX  ,FRUITY  );
		putmapchar(FRUITX+1,FRUITY  );
		putmapchar(FRUITX-1,FRUITY+1);
		putmapchar(FRUITX  ,FRUITY+1);
		putmapchar(FRUITX+1,FRUITY+1);
	}
}
void getfruit(){
	// t[cHׂ

	score+=fruitscore[fruitno];
	fruitcount=0;
	setfruit(0);
	fruitsound=22000;
	fruitsoundcount=20;
	fruitscoretimer=TIMER_FRUITSCORE;
}

void displayscore(){
	if(score>highscore) highscore=score;
	gprintnum2(21*8,3*8,7,0,highscore,6);
	gprintnum2(21*8,7*8,7,0,score,6);
}
#ifndef BOOTLOADER
void writehighscore(void){
	//nCXRÃtbV
	NVMErasePage((void *)FLASHPAGE);//y[W
	NVMWriteWord((void *)FLASHPAGE,highscore);//[h
}
#endif
void displayplayers(){
	//vC[c\
	unsigned char i;
	for(i=0;i<player && i<5;i++) putbmpmn(22*8+i*16,23*8,XWIDTH_PACMAN,YWIDTH_PACMAN,Pacmanbmp[11]);
	for(;i<4;i++) clrbmpmn(22*8+i*16,23*8,XWIDTH_PACMAN,YWIDTH_PACMAN);
}
void displayfruits(){
	//ʉE8Xe[W̃t[c\
	unsigned char i,no;
	for(i=0;i<8 && i<stage;i++){
		no=getfruitno(stage-i);
		clrbmpmn (22*8+(i%4)*16,15*8+(i/4)*16,12,14);
		putbmpmn(22*8+(i%4)*16,15*8+(i/4)*16,12,14,Fruitbmp[no]);
	}
}
void putmap(void){
	//ʘHAAp[̕\
	unsigned char c,*p,*mapp;
	int i,j,k;
	clearscreen();
	p=scenedata;
	mapp=map;
	cookie=0;
	for(i=0;i<MAPYSIZE;i++){
		for(j=0;j<MAPXSIZE;j++){
			if(*p<=0x8d){
				*mapp=MAP_WALL; //
				gputfont(j*8,i*8,COLOR_WALL,0,*p);
			}
			else if(*p==CODE_DOOR){
				*mapp=MAP_DOOR; //hA
				gputfont(j*8,i*8,COLOR_DOOR,0,CODE_DOOR);
			}
			else if(*p==CODE_COOKIE){
				*mapp=MAP_COOKIE; //
				gputfont(j*8,i*8,COLOR_COOKIE,0,CODE_COOKIE);
				cookie++;
			}
			else if(*p==CODE_POWERCOOKIE){
				*mapp=MAP_POWERCOOKIE; //p[
				gputfont(j*8,i*8,COLOR_POWERCOOKIE,0,CODE_POWERCOOKIE);
				cookie++;
			}
			else *mapp=0;
			p++;
			mapp++;
		}
	}
	gprintstr(21*8,1*8,7,0,"HI-SCORE");
	gputfont(27*8,3*8,7,0,'0');
	gprintstr(22*8,5*8,7,0,"1UP");
	gputfont(27*8,7*8,7,0,'0');
	displayscore();
	displayplayers();
	displayfruits();
}
void initcharacter(_Character *p,unsigned char s,unsigned short x,unsigned short y,
					unsigned char dir,unsigned short speed,unsigned char ac,unsigned short modec)
{
	//LN^[
	//p:LN^[̃|C^As:[histatusjAix,y):ʒuAdir:
	//speed:ړxAac:Aj[VJE^AmodecF[hJE^[
	p->status=s;
	p->x=x;
	p->y=y;
	p->oldx=x;
	p->oldy=y;
	p->dir=dir;
	p->turn=0;
	p->speed=speed;
	p->animcount=ac;
	p->animcount0=ac;
	p->animvalue=0;
	p->modecount=modec;
}

void gameinit(void)
{
// Q[Ŝ̏BN1񂾂
	set_palette(COLOR_GUZUTA,70,200,128); //OY^̐F
	set_palette(COLOR_PINKY,180,230,128); //sL[̐F
	set_palette(COLOR_WALL,250,20,40); //ǂ̐F
	set_palette(COLOR_POWERCOOKIE,0,255,255); //p[̐F
	set_palette(COLOR_ORANGE,0,255,165); //݂̐F
	set_palette(COLOR_MONSTERNUDE,180,245,220); //̃X^[̐F
	akabei.no=AKABEI;
	aosuke.no=AOSUKE;
	guzuta.no=GUZUTA;
	pinky.no=PINKY;

	score=0;
}
void gameinit2(void)
{
// Q[BvC{^ŖĂяo
	score=0;
	player=3;
	upflag=0;//1000_zŃvC[+1̃`FbNp
	stage=0;
	firekeyold=0;
}
void gameinit3(void)
{
// V[NAƂɌĂяo
	if(stage<STAGEMAX-1){
		ijiketime=ijike[stage];
		pacmanspeed=pacmansp[stage];
		monsterspeed=monstersp[stage];
		ijikespeed=ijikesp[stage];
		medamaspeed=medamasp[stage];
	}
	else{
		ijiketime=ijike[STAGEMAX-1];
		pacmanspeed=pacmansp[STAGEMAX-1];
		monsterspeed=monstersp[STAGEMAX-1];
		ijikespeed=ijikesp[STAGEMAX-1];
		medamaspeed=medamasp[STAGEMAX-1];
	}
	stage++;
	fruitflag1=1;//ʑÕt[ccĂ
	fruitflag2=1;//ʌ㔼̃t[ccĂ
	fruitno=getfruitno(stage);
	putmap();//ʘH̕\
}
void gameinit4(void)
{
// pbN}邲ƁAуV[NAƂɌĂяo
	fruitcount=0;
	fruitscoretimer=0;
	huntedmonster=0;
	monsterhuntedtimer=0;
	monstersoundcount=0;
	cookiesoundcount=0;
	fruitsoundcount=0;
	over10000soundcount=0;
	setfruit(0);//t[c폜A\
	initcharacter(&pacman,0,10*8*256,20*8*256,DIR_LEFT,pacmanspeed,5,0);
	initcharacter(&akabei,NAWABARI,MONSTERHOUSEX*8*256,(MONSTERHOUSEY-2)*8*256,DIR_LEFT,monsterspeed,0,550);
	initcharacter(&pinky ,NAWABARI,MONSTERHOUSEX*8*256,(MONSTERHOUSEY+1)*8*256,DIR_UP,monsterspeed,0,0);
	initcharacter(&aosuke,TAIKI2,(MONSTERHOUSEX-1)*8*256,(MONSTERHOUSEY+1)*8*256,DIR_DOWN,monsterspeed,0,375);
	initcharacter(&guzuta,TAIKI2,(MONSTERHOUSEX+1)*8*256,(MONSTERHOUSEY+1)*8*256,DIR_DOWN,monsterspeed,0,600);
}

void keycheck()
{
	// {^`FbNAǂłȂ΃pbN}̌ύX
	unsigned short k;
	unsigned char d;
	unsigned short x,y;

	x=pacman.x/256;
	y=pacman.y/256;
	k=~KEYPORT & (KEYUP | KEYDOWN | KEYLEFT | KEYRIGHT);
	if(k==KEYUP && (x%8)==0){	//{^
		if(pacman.dir!=DIR_UP){
			if(y>=8){
				if(GETMAP(x/8,y/8-1)!=MAP_WALL) pacman.dir=DIR_UP;
			}
			else pacman.dir=DIR_UP;
		}
	}
	else if(k==KEYRIGHT && (y%8)==0){	//E{^
		if(pacman.dir!=DIR_RIGHT){
			if(x<=(MAPXSIZE-2)*8){
				if(GETMAP(x/8+1,y/8)!=MAP_WALL) pacman.dir=DIR_RIGHT;
			}
			else pacman.dir=DIR_RIGHT;
		}
	}
	else if(k==KEYDOWN && (x%8)==0){	//{^
		if(pacman.dir!=DIR_DOWN){
			if(y<=(MAPYSIZE-2)*8){
				d=GETMAP(x/8,y/8+1);
				if(d!=MAP_WALL && d!=MAP_DOOR) pacman.dir=DIR_DOWN;
			}
			else pacman.dir=DIR_DOWN;
		}
	}
	else if(k==KEYLEFT && (y%8)==0){	//{^
		if(pacman.dir!=DIR_LEFT){
			if(x>=8){
				if(GETMAP(x/8-1,y/8)!=MAP_WALL) pacman.dir=DIR_LEFT;
			}
			else pacman.dir=DIR_LEFT;
		}
	}
}
void pausecheck(void){
	//FIRE{^ňꎞ~
	//firekeyoldŃL[s[g`FbN
	unsigned short k;
	k=~KEYPORT & KEYFIRE;
	if(firekeyold==KEYFIRE || k!=KEYFIRE){
		firekeyold=k;
		return;
	}
	firekeyold=k;
	PR3=0; //TEh~
	while(1){
		//xFIRE{^܂Ń[v
		drawcount=0;
		while(drawcount==0) asm("wait");
		k=~KEYPORT & KEYFIRE;
		if(firekeyold!=KEYFIRE && k==KEYFIRE){
			firekeyold=k;
			return;
		}
		firekeyold=k;
	}
}

void movepacman(){
	//pbN}ړ`FbN
	unsigned char t;
	unsigned short x,y;

	if(monsterhuntedtimer>0) return; //X^[ߊl͒~
	x=pacman.x/256;
	y=pacman.y/256;
	switch(pacman.dir){
		case DIR_UP: //
			if(y!=0){
				if((y%8)!=0 || GETMAP(x/8,y/8-1)!=MAP_WALL) pacman.y-=pacman.speed;
			}
			else pacman.y=(MAPYSIZE-1)*8*256;
			break;
		case DIR_RIGHT: //E
			if(x!=(MAPXSIZE-1)*8){
				if((x%8)!=0 || GETMAP(x/8+1,y/8)!=MAP_WALL) pacman.x+=pacman.speed;
			}
			else pacman.x=0;
			break;
		case DIR_DOWN: //BX^[nEX̃hAǂƂ݂Ȃ
			if(y!=(MAPYSIZE-1)*8){
				t=GETMAP(x/8,y/8+1);
				if((y%8)!=0 || t!=MAP_WALL && t!=MAP_DOOR) pacman.y+=pacman.speed;
			}
			else pacman.y=0;
			break;
		case DIR_LEFT: //
			if(x!=0){
				if((x%8)!=0 || GETMAP(x/8-1,y/8)!=MAP_WALL) pacman.x-=pacman.speed;
			}
			else pacman.x=(MAPXSIZE-1)*8*256;
	}
}
void movemonster(_Character *p,unsigned short tx,unsigned short ty){
	//X^[̈ړ肵Aړ
	//p:X^[̃|C^Atx:ڕWxWAty:ڕWyW
	unsigned char cUP,cRIGHT,cDOWN,cLEFT;
	unsigned char t;
	unsigned char olddir;
	unsigned short x,y,x1,y1,oldx,oldy;

	x=p->x/256;
	y=p->y/256;
	x1=x/8;
	y1=y/8;
	oldx=p->oldx;
	oldy=p->oldy;
	p->oldx=p->x;
	p->oldy=p->y;
	olddir=p->dir;

	switch(p->dir){
	//ύXA_ȏړ܂Œi
	//܂Ai_ȉړ̏ꍇ͒i
		case DIR_UP: //
			if(p->turn && y==oldy/256){
				p->y-=p->speed;
				return;
			}
			p->turn=0;
			if(y==(unsigned short)((p->y-p->speed))/256){
				p->y-=p->speed;
				return;
			}
			break;
		case DIR_RIGHT: //E
			if(p->turn && x==oldx/256){
				p->x+=p->speed;
				return;
			}
			p->turn=0;
			if(x==(p->x+p->speed)/256){
				p->x+=p->speed;
				return;
			}
			break;
		case DIR_DOWN: //
			if(p->turn && y==oldy/256){
				p->y+=p->speed;
				return;
			}
			p->turn=0;
			if(y==(p->y+p->speed)/256){
				p->y+=p->speed;
				return;
			}
			break;
		case DIR_LEFT: //
			if(p->turn && x==oldx/256){
				p->x-=p->speed;
				return;
			}
			p->turn=0;
			if(x==(unsigned short)((p->x-p->speed))/256){
				p->x-=p->speed;
				return;
			}
	}

	//cUPAcRIGHTAcDOWNAcLEFT:ꂼ̕ɒʂꍇ1AʂȂꍇ0Ƃ
	cUP=1;
	cRIGHT=1;
	cDOWN=1;
	cLEFT=1;
	if((x%8)!=0){
		cUP=0;
		cDOWN=0;
	}
	else if((y%8)==0){
		if(y1!=0 && GETMAP(x1,y1-1)==MAP_WALL) cUP=0;
		//ڋʂ̂ƂȊO͈ʍs`FbN
		else if(p->status!=MEDAMA &&
		  (x1==ONEWAY1X && y1==ONEWAY1Y+1 || x1==ONEWAY2X && y1==ONEWAY2Y+1 ||
		   x1==ONEWAY3X && y1==ONEWAY3Y+1 || x1==ONEWAY4X && y1==ONEWAY4Y+1)) cUP=0;
		if(y1!=MAPYSIZE-1){
			//ڋʂ̂ƂȊO̓hAǂƂ݂Ȃ
			t=GETMAP(x1,y1+1);
			if(t==MAP_WALL || (t==MAP_DOOR && p->status!=MEDAMA)) cDOWN=0;
		}
	}

	if((y%8)!=0){
		cRIGHT=0;
		cLEFT=0;
	}
	else if((x%8)==0){
		if(x1!=MAPXSIZE-1 && GETMAP(x1+1,y1)==MAP_WALL) cRIGHT=0;
		if(x1!=0 && GETMAP(x1-1,y1)==MAP_WALL) cLEFT=0;
	}

	tx>>=8;
	ty>>=8;
	if(p->status==TAIKI2){
		if(y==MONSTERHOUSEY*8) p->dir=DIR_DOWN;
		else if(y==(MONSTERHOUSEY+1)*8) p->dir=DIR_UP;
	}
	else switch(p->dir){
		case DIR_UP: //is=EEED揇ʁ@Eと
			if(x<tx && cRIGHT) p->dir=DIR_RIGHT;
			else if(y>ty && cUP) p->dir=DIR_UP;
			else if(x>tx && cLEFT) p->dir=DIR_LEFT;
			else if(cRIGHT) p->dir=DIR_RIGHT;
			else if(cUP) p->dir=DIR_UP;
			else p->dir=DIR_LEFT;
			break;
		case DIR_RIGHT: //is=EEEED揇ʁ@E
			if(y<ty && cDOWN) p->dir=DIR_DOWN;
			else if(x<tx && cRIGHT) p->dir=DIR_RIGHT;
			else if(y>ty && cUP) p->dir=DIR_UP;
			else if(cDOWN) p->dir=DIR_DOWN;
			else if(cRIGHT) p->dir=DIR_RIGHT;
			else p->dir=DIR_UP;
			break;
		case DIR_DOWN: //is=EEED揇ʁ@E
			if(x>tx && cLEFT) p->dir=DIR_LEFT;
			else if(y<ty && cDOWN) p->dir=DIR_DOWN;
			else if(x<tx && cRIGHT) p->dir=DIR_RIGHT;
			else if(cLEFT) p->dir=DIR_LEFT;
			else if(cDOWN) p->dir=DIR_DOWN;
			else p->dir=DIR_RIGHT;
			break;
		case DIR_LEFT: //is=EEED揇ʁ@と
			if(y>ty && cUP) p->dir=DIR_UP;
			else if(x>tx && cLEFT) p->dir=DIR_LEFT;
			else if(y<ty && cDOWN) p->dir=DIR_DOWN;
			else if(cUP) p->dir=DIR_UP;
			else if(cLEFT) p->dir=DIR_LEFT;
			else p->dir=DIR_DOWN;
	}
	if(p->dir != olddir) p->turn=1;
	switch(p->dir){
		case DIR_UP: //
			if(y!=0) p->y-=p->speed;
			else p->y=(MAPYSIZE-1)*8*256;
			break;
		case DIR_RIGHT: //E
			if(x!=(MAPXSIZE-1)*8){
				//[v][ŃXs[h𗎂Ƃ
				if(y1==WARPY && (x1<WARPX1 || x1>=WARPX2) && p->status!=MEDAMA) p->x+=p->speed/2;
				else p->x+=p->speed;
			}
			else p->x=0;
			break;
		case DIR_DOWN: //
			if(y!=(MAPYSIZE-1)*8) p->y+=p->speed;
			else p->y=0;
			break;
		case DIR_LEFT: //
			if(x!=0){
				//[v][ŃXs[h𗎂Ƃ
				if(y1==WARPY && (x1<WARPX1 || x1>=WARPX2) && p->status!=MEDAMA) p->x-=p->speed/2;
				else p->x-=p->speed;
			}
			else p->x=(MAPXSIZE-1)*8*256;
	}
}

void moveakabei(){
	//AJxCړ
	unsigned short targetx,targety;

	if(monsterhuntedtimer>0 && akabei.status!=MEDAMA) return; //NߊlĂƂڋʈȊO͒~
	switch (akabei.status){
		case NAWABARI:
			akabei.modecount--;
			if(akabei.modecount==0){
				akabei.modecount=TIMER_OIKAKE;
				akabei.status=OIKAKE;
				akabei.dir=(akabei.dir+2)&3; //]
				akabei.turn=0;
				//̃X^[ɕύX
				if(pinky.status==NAWABARI){
					pinky.status=OIKAKE;
					pinky.dir=(pinky.dir+2)&3;
					pinky.turn=0;
				}
				if(aosuke.status==NAWABARI){
					aosuke.status=OIKAKE;
					aosuke.dir=(aosuke.dir+2)&3;
					aosuke.turn=0;
				}
				if(guzuta.status==NAWABARI){
					guzuta.status=OIKAKE;
					guzuta.dir=(guzuta.dir+2)&3;
					guzuta.turn=0;
				}
			}
			break;
		case OIKAKE:
			akabei.modecount--;
			if(akabei.modecount==0){
				akabei.modecount=TIMER_NAWABARI;
				akabei.status=NAWABARI;
				akabei.dir=(akabei.dir+2)&3; //]
				akabei.turn=0;
				if(pinky.status==OIKAKE){
					pinky.status=NAWABARI;
					pinky.dir=(pinky.dir+2)&3;
					pinky.turn=0;
				}
				if(aosuke.status==OIKAKE){
					aosuke.status=NAWABARI;
					aosuke.dir=(aosuke.dir+2)&3;
					aosuke.turn=0;
				}
				if(guzuta.status==OIKAKE){
					guzuta.status=NAWABARI;
					guzuta.dir=(guzuta.dir+2)&3;
					guzuta.turn=0;
				}
			}
			break;
		case IJIKE:
			akabei.modecount--;
			if(akabei.modecount==0){
				akabei.status=OIKAKE;
				akabei.modecount=TIMER_OIKAKE;
				akabei.speed=monsterspeed;
			}
			break;
		case MEDAMA:
			if((akabei.x/256)==(MONSTERHOUSEX*8) && (akabei.y/256)==(MONSTERHOUSEY*8)){ //X^[nEX
				akabei.status=TAIKI2;
				akabei.modecount=1;
				akabei.dir=DIR_UP;
				akabei.speed=monsterspeed;
			}
			break;
		case TAIKI:
			if((akabei.x/256)==(MONSTERHOUSEX*8) && (akabei.y/256)==((MONSTERHOUSEY-2)*8)){ //X^[nEXo
				akabei.status=OIKAKE;
				akabei.modecount=TIMER_OIKAKE;
				akabei.dir=DIR_LEFT;
			}
			break;
		case TAIKI2:
			akabei.modecount--;
			if(akabei.modecount==0){
				akabei.status=TAIKI;
			}
	}
	switch (akabei.status){
		case NAWABARI:
		case IJIKE:
			targetx=NAWABARIAKABEIX*8*256;
			targety=NAWABARIAKABEIY*8*256;
			break;
		case OIKAKE:
			targetx=pacman.x;
			targety=pacman.y;
			break;
		case MEDAMA:
			targetx=MONSTERHOUSEX*8*256;
			targety=MONSTERHOUSEY*8*256;
			break;
		case TAIKI:
			targetx=MONSTERHOUSEX*8*256;
			targety=(MONSTERHOUSEY-2)*8*256;
	}
	movemonster(&akabei,targetx,targety);
}

void movepinky(){
	//sL[ړ
	unsigned short targetx,targety;

	if(monsterhuntedtimer>0 && pinky.status!=MEDAMA) return; //NߊlĂƂڋʈȊO͒~
	switch (pinky.status){
		case NAWABARI:
		case OIKAKE:
			break;
		case IJIKE:
			pinky.modecount--;
			if(pinky.modecount==0){
				pinky.status=OIKAKE;
				pinky.speed=monsterspeed;
			}
			break;
		case MEDAMA:
			if((pinky.x/256)==(MONSTERHOUSEX*8) && (pinky.y/256)==(MONSTERHOUSEY*8)){ //X^[nEX
				pinky.status=TAIKI2;
				pinky.modecount=1;
				pinky.dir=DIR_UP;
				pinky.speed=monsterspeed;
			}
			else pinky.speed=medamaspeed;
			break;
		case TAIKI:
			if((pinky.x/256)==(MONSTERHOUSEX*8) && (pinky.y/256)==((MONSTERHOUSEY-2)*8)){ //X^[nEXo
				pinky.status=OIKAKE;
				pinky.dir=DIR_LEFT;
			}
			break;
		case TAIKI2:
			pinky.modecount--;
			if(pinky.modecount==0){
				pinky.status=TAIKI;
			}
	}
	switch (pinky.status){
		case NAWABARI:
			targetx=NAWABARIPINKYX*8*256;
			targety=NAWABARIPINKYY*8*256;
			break;
		case IJIKE:
			targetx=MONSTERHOUSEX*8*256;
			targety=MONSTERHOUSEY*8*256;
			break;
		case OIKAKE: //pbN}̐is+3^[QbgWƂ
			if(pacman.dir==DIR_UP){
				targetx=pacman.x;
				if(pacman.y>=4*8*256) targety=pacman.y-3*8*256;
				else if(pacman.y/256/8==0) targety=(MAPYSIZE-3)*8*256;
				else targety=1*8*256;
			}
			else if(pacman.dir==DIR_RIGHT){
				targety=pacman.y;
				if(pacman.x<=(MAPXSIZE-5)*8*256) targetx=pacman.x+3*8*256;
				else if(pacman.x/256/8==(MAPXSIZE-1)*8) targetx=2*8*256;
				else targetx=(MAPXSIZE-2)*8*256;
			}
			else if(pacman.dir==DIR_DOWN){
				targetx=pacman.x;
				if(pacman.y<=(MAPYSIZE-5)*8*256) targety=pacman.y+3*8*256;
				else if(pacman.y/256/8==(MAPYSIZE-1)*8) targety=2*8*256;
				else targety=(MAPYSIZE-2)*8*256;
			}
			else if(pacman.dir==DIR_LEFT){
				targety=pacman.y;
				if(pacman.x>=4*8*256) targetx=pacman.x-3*8*256;
				else if(pacman.x/256/8==0) targetx=(MAPXSIZE-3)*8*256;
				else targetx=1*8*256;
			}
			break;
		case MEDAMA:
			targetx=MONSTERHOUSEX*8*256;
			targety=MONSTERHOUSEY*8*256;
			break;
		case TAIKI:
			targetx=MONSTERHOUSEX*8*256;
			targety=(MONSTERHOUSEY-2)*8*256;
	}
	movemonster(&pinky,targetx,targety);
}

void moveaosuke()
{
	//AIXPړ
	unsigned short targetx,targety;

	if(monsterhuntedtimer>0 && aosuke.status!=MEDAMA) return; //NߊlĂƂڋʈȊO͒~
	switch (aosuke.status){
		case NAWABARI:
		case OIKAKE:
			break;
		case IJIKE:
			aosuke.modecount--;
			if(aosuke.modecount==0){
				aosuke.status=OIKAKE;
				aosuke.speed=monsterspeed;
			}
			break;
		case MEDAMA:
			if((aosuke.x/256)==(MONSTERHOUSEX*8) && (aosuke.y/256)==(MONSTERHOUSEY*8)){ //X^[nEX
				aosuke.status=TAIKI2;
				aosuke.modecount=1;
				aosuke.dir=DIR_UP;
				aosuke.speed=monsterspeed;
			}
			break;
		case TAIKI:
			if((aosuke.x/256)==(MONSTERHOUSEX*8) && (aosuke.y/256)==((MONSTERHOUSEY-2)*8)){ //X^[nEXo
				aosuke.status=OIKAKE;
				aosuke.dir=DIR_LEFT;
			}
			break;
		case TAIKI2:
			aosuke.modecount--;
			if(aosuke.modecount==0){
				aosuke.status=TAIKI;
			}
	}
	switch (aosuke.status){
		case NAWABARI:
			targetx=NAWABARIAOSUKEX*8*256;
			targety=NAWABARIAOSUKEY*8*256;
			break;
		case IJIKE:
			targetx=MONSTERHOUSEX*8*256;
			targety=MONSTERHOUSEY*8*256;
			break;
		case OIKAKE: //pbN}SɃAJxCƓ_Ώ̂̈ʒu^[QbgWƂ
			targetx=pacman.x/2-akabei.x/4;
			targety=pacman.y/2-akabei.y/4;
			if(targetx>=32768) targetx=0;
			else if(targetx>=16384) targetx=16383;
			if(targety>=32768) targety=0;
			else if(targety>=16384) targety=16383;
			targetx<<=2;
			targety<<=2;
			break;
		case MEDAMA:
			targetx=MONSTERHOUSEX*8*256;
			targety=MONSTERHOUSEY*8*256;
			break;
		case TAIKI:
			targetx=MONSTERHOUSEX*8*256;
			targety=(MONSTERHOUSEY-2)*8*256;
	}
	movemonster(&aosuke,targetx,targety);
}

void moveguzuta()
{
	//OY^ړ
	unsigned short targetx,targety;
	short dx,dy;

	if(monsterhuntedtimer>0 && guzuta.status!=MEDAMA) return; //NߊlĂƂڋʈȊO͒~
	switch (guzuta.status){
		case NAWABARI:
		case OIKAKE:
			break;
		case IJIKE:
			guzuta.modecount--;
			if(guzuta.modecount==0){
				guzuta.status=OIKAKE;
				guzuta.speed=monsterspeed;
			}
			break;
		case MEDAMA:
			if((guzuta.x/256)==(MONSTERHOUSEX*8) && (guzuta.y/256)==(MONSTERHOUSEY*8)){ //X^[nEX
				guzuta.status=TAIKI2;
				guzuta.modecount=1;
				guzuta.dir=DIR_UP;
				guzuta.speed=monsterspeed;
			}
			break;
		case TAIKI:
			if((guzuta.x/256)==(MONSTERHOUSEX*8) && (guzuta.y/256)==((MONSTERHOUSEY-2)*8)){ //X^[nEXo
				guzuta.status=OIKAKE;
				guzuta.dir=DIR_LEFT;
			}
			break;
		case TAIKI2:
			guzuta.modecount--;
			if(guzuta.modecount==0){
				guzuta.status=TAIKI;
			}
	}
	switch (guzuta.status){
		case NAWABARI:
			targetx=NAWABARIGUZUTAX*8*256;
			targety=NAWABARIGUZUTAY*8*256;
			break;
		case IJIKE:
			targetx=MONSTERHOUSEX*8*256;
			targety=MONSTERHOUSEY*8*256;
			break;
		case OIKAKE: //pbN}牓ɂƂ͋߂ÂĂ邪A߂Âƕʂڎw
			dx=(short)(guzuta.x/256/8)-(short)(pacman.x/256/8);
			dy=(short)(guzuta.y/256/8)-(short)(pacman.y/256/8);
			if(dx*dx+dy*dy>10){
				targetx=pacman.x;
				targety=pacman.y;
			}
			else{
				targetx=NAWABARIGUZUTAX*8*256;
				targety=NAWABARIGUZUTAY*8*256;
			}
			break;
		case MEDAMA:
			targetx=MONSTERHOUSEX*8*256;
			targety=MONSTERHOUSEY*8*256;
			break;
		case TAIKI:
			targetx=MONSTERHOUSEX*8*256;
			targety=(MONSTERHOUSEY-2)*8*256;
	}
	movemonster(&guzuta,targetx,targety);
}

void sound(void){
	//ʉo
	//601bƂɌĂяo
	//̂قŏ̂قǗDIɖ炷
	unsigned short pr;//^C}[JE^[l
	unsigned short monsterspeed2;
	pr=0;
	monsterspeed2=2048/monsterspeed;

//X^[̉
	if(akabei.status==MEDAMA || pinky.status==MEDAMA || aosuke.status==MEDAMA || guzuta.status==MEDAMA){
	//ڋʁEEEpr2200?3000ŘAωAXs[hƕω
		if(monstersoundcount==0){
			monstersound=2200;
			monstersounddif=800/monsterspeed2;
		}
		else monstersound+=monstersounddif;
		pr=monstersound;
		monstersoundcount++;
		if(monstersoundcount>monsterspeed2) monstersoundcount=0;
	}
	else if(akabei.status==IJIKE || pinky.status==IJIKE || aosuke.status==IJIKE || guzuta.status==IJIKE){
	//CWPEEEpr7600?3800ŘAωAXs[hƕω
		if(monstersoundcount==0){
			monstersounddif=7600/monsterspeed2;
			monstersound=3800+(monsterspeed2>>1)*monstersounddif;
		}
		else monstersound-=monstersounddif;
		pr=monstersound;
		monstersoundcount++;
		if(monstersoundcount*2>monsterspeed2) monstersoundcount=0;
	}
	else{
	//ʏ
		if(monstersoundcount==0){
			monstersound=2500+monsterspeed2*60;
			monstersounddif=monstersound/monsterspeed2;
		}
		else if(monstersoundcount<monsterspeed2) monstersound+=monstersounddif;
		else monstersound-=monstersounddif;
		pr=monstersound;
		monstersoundcount++;
		if(monstersoundcount>monsterspeed2*2) monstersoundcount=0;
	}

//Hׂ鉹
	if(cookiesoundcount!=0){
		if((cookie&1)==0){
			if(cookiesoundcount>3) pr=32000;
			else pr=16000;
		}
		else{
			if(cookiesoundcount>3) pr=16000;
			else pr=32000;
		}
		cookiesoundcount--;
	}
//t[cHׂ鉹0.3b
	if(fruitsoundcount!=0){
		pr=fruitsound;
		fruitsound-=670;
		fruitsoundcount--;
	}
//CWPHׂ鉹60/60bA8FAA21񉹂炵ύX
	if(monsterhuntedtimer>0){
		if(monsterhuntedtimer&1){
			pr=monsterhuntedsound;
			monsterhuntedsound-=50;
		}
	}
//10000_zApbN}+1 G8炷
	if(over10000soundcount!=0){
		if((over10000soundcount&7)<6) pr=4565;
		over10000soundcount--;
	}

	PR3=pr; //ۂɎύX
}

void erasechars2(_Character *p){
// 1LN^[\ꏊ̎͊܂߂ď
	unsigned short x,y;
	unsigned char x2,y2;

	x=p->x/256;
	y=p->y/256;
	x2=(unsigned char)(x/8);
	y2=(unsigned char)(y/8);
	if((y%8)<3 && y2>0){
		if((x%8)<4 && x2>0) putmapchar(x2-1,y2-1);
		putmapchar(x2,y2-1);
		if(x2<MAPXSIZE-1) putmapchar(x2+1,y2-1);
		if((x%8)>=5 && x2<MAPXSIZE-2) putmapchar(x2+2,y2-1);
	}
	if((x%8)<4 && x2>0) putmapchar(x2-1,y2);
	putmapchar(x2,y2);
	if(x2<MAPXSIZE-1) putmapchar(x2+1,y2);
	if((x%8)>=5 && x2<MAPXSIZE-2) putmapchar(x2+2,y2);
	if(y2<MAPYSIZE-1){
		if((x%8)<4 && x2>0) putmapchar(x2-1,y2+1);
		putmapchar(x2,y2+1);
		if(x2<MAPXSIZE-1) putmapchar(x2+1,y2+1);
		if((x%8)>=5 && x2<MAPXSIZE-2) putmapchar(x2+2,y2+1);
	}
	if((y%8)>=6 && y2<MAPYSIZE-2){
		if((x%8)<4 && x2>0) putmapchar(x2-1,y2+2);
		putmapchar(x2,y2+2);
		if(x2<MAPXSIZE-1) putmapchar(x2+1,y2+2);
		if((x%8)>=5 && x2<MAPXSIZE-2) putmapchar(x2+2,y2+2);
	}
}
void erasechars(){
	// \̏i̕\ɖ߂j
	erasechars2(&pacman);
	erasechars2(&akabei);
	erasechars2(&pinky);
	erasechars2(&aosuke);
	erasechars2(&guzuta);
}

void displaychars(){
	// t[cACWPApbN}ACWPȊÕX^[̏ɕ\
	blinkpowercookie(); //p[̓_
	if(fruitcount>0) putfruit();
	else if(fruitscoretimer>0) putbmpmn(FRUITX*8-4,FRUITY*8,XWIDTH_SCORE,YWIDTH_SCORE,Scorebmp[4+fruitno]);
	if(akabei.status==IJIKE) putmonster(&akabei);
	if(aosuke.status==IJIKE) putmonster(&aosuke);
	if(guzuta.status==IJIKE) putmonster(&guzuta);
	if(pinky.status==IJIKE) putmonster(&pinky);
	if(monsterhuntedtimer!=0)//CWPHׂƂ̓_\
		putbmpmn((int)(pacman.x/256)-4,(int)(pacman.y/256),XWIDTH_SCORE,YWIDTH_SCORE,Scorebmp[huntedmonster-1]);
	else putpacman();
	if(akabei.status!=IJIKE) putmonster(&akabei);
	if(aosuke.status!=IJIKE) putmonster(&aosuke);
	if(guzuta.status!=IJIKE) putmonster(&guzuta);
	if(pinky.status!=IJIKE) putmonster(&pinky);
}
void fruitcheck(){
	//t[coAŃ`FbNA
	if(fruitflag1 && cookie==FRUITTIME1){
		fruitflag1=0;
		setfruit(1);
		fruitcount=TIMER_FRUIT;
	}
	else if(fruitflag2 && cookie==FRUITTIME2){
		fruitflag2=0;
		setfruit(1);
		fruitcount=TIMER_FRUIT;
	}
	else if(fruitcount>0){
		fruitcount--;
		if(fruitcount==0) setfruit(0);//Ԑ؂Ńt[c
	}
	else if(fruitscoretimer>0){ //t[cHׂƂ̃XRA
		fruitscoretimer--;
		if(fruitscoretimer==0){
			putmapchar(FRUITX-1,FRUITY);
			putmapchar(FRUITX  ,FRUITY);
			putmapchar(FRUITX+1,FRUITY);
		}
	}
}

void movechars(){
	//eLN^[̈ړ
	movepacman();
	moveakabei();
	movepinky();
	moveaosuke();
	moveguzuta();
	if(monsterhuntedtimer>0) monsterhuntedtimer--;
}

void setmonsterijike(_Character *p){
	// X^[Ԃɂ
	if(p->status==MEDAMA) return;
//	if(p->status==TAIKI || p->status==TAIKI2) return;
	p->dir=(p->dir+2)&3; //]
	p->turn=0;
	if(ijiketime!=0){
		p->status=IJIKE;
		p->modecount=ijiketime;
		p->speed=ijikespeed;
	}
}

unsigned char monsterhuntcheck(_Character *p){
	//@X^[ߊl`FbN
	//@߂l@0:ߊlȂA1:CWPߊlA2:pbN}X^[ɂꂽ
#define HANTEI 7 // WǂꂾdȂɕߊlƔ肷邩̕ߊll

	short dx,dy;

	if(p->status==MEDAMA) return 0;
	dx=(short)(p->x/256)-(short)(pacman.x/256);
	dy=(short)(p->y/256)-(short)(pacman.y/256);
	if(dx!=0 && dy!=0) return 0;
	if(dx<=-(XWIDTH_MONSTER-HANTEI) || dx>=XWIDTH_PACMAN-HANTEI ||
	   dy<=-(YWIDTH_MONSTER-HANTEI) || dy>=YWIDTH_PACMAN-HANTEI) return 0;
	if(p->status==IJIKE){
		p->status=MEDAMA;
		p->x&=0xfeff; //ڋʂ̈ړx1hbg΂̂߁AIɋWɂ
		p->y&=0xfeff; //
		huntedmonster++;
		p->speed=medamaspeed;
		score+=(1<<huntedmonster)*10;
		monsterhuntedtimer=TIMER_HUNTEDSTOP;//~
		monsterhuntedsound=5100;
		return 1;
	}
	gamestatus=2;
	return 2;
}
void huntedcheck(void){
	//@e̕ߊlAՓ˃`FbN

	unsigned char d,x,y;

	if(monsterhuntedtimer>0) return; //ڋʈȊO~
	x=pacman.x/256;
	y=pacman.y/256;
	if((x%8)==4 || (y%8)==4){
		x/=8;
		y/=8;
		if(pacman.dir==DIR_RIGHT) x++;
		else if(pacman.dir==DIR_DOWN) y++;
		d=GETMAP(x,y);
		if(d==MAP_COOKIE){
			//Hׂ
			SETMAP(x,y,MAP_NONE);
			score++;
			cookie--;
			cookiesoundcount=4;
		}
		else if(d==MAP_POWERCOOKIE){
			//p[Hׂ
			SETMAP(x,y,MAP_NONE);
			score+=5;
			cookie--;
			cookiesoundcount=4;
			huntedmonster=0;
			setmonsterijike(&akabei);
			setmonsterijike(&pinky);
			setmonsterijike(&aosuke);
			setmonsterijike(&guzuta);
		}
		else if(d==MAP_FRUIT){
			//t[cHׂ
			getfruit();
		}
		if(cookie==0){
			//Xe[WNA
			gamestatus=3;
			return;
		}
	}
	if(akabei.status==IJIKE && monsterhuntcheck(&akabei)) return;
	if(pinky.status==IJIKE && monsterhuntcheck(&pinky)) return;
	if(aosuke.status==IJIKE && monsterhuntcheck(&aosuke)) return;
	if(guzuta.status==IJIKE && monsterhuntcheck(&guzuta)) return;
	if(upflag==0 && score>=1000){
		upflag=1;
		player++;
		displayplayers();
		over10000soundcount=63;
	}
	if(akabei.status!=IJIKE && monsterhuntcheck(&akabei)) return;
	if(pinky.status!=IJIKE && monsterhuntcheck(&pinky)) return;
	if(aosuke.status!=IJIKE && monsterhuntcheck(&aosuke)) return;
	if(guzuta.status!=IJIKE && monsterhuntcheck(&guzuta)) return;
}

// R[q[uCN1?3
void coffeebreak1(void){
	unsigned char i;
	unsigned char a1,ac1,av1;
	unsigned char a2,ac2;
	int pacx,akax,pacspeed,akaspeed;
	clearscreen();
	pacx=255*256;
	akax=300*256;
	ac1=5;
	av1=0;
	a2=0;
	ac2=4;
	pacspeed=-290*256/245;
	akaspeed=-320*256/245;
	startmusic(musicdata2);
	while(akax>-20*256){
		ac1--;
		if(ac1==0){
			ac1=5;
			av1++;
			if(av1==6) av1=0;
		}
		if(av1==0) a1=0;
		else if(av1<=3) a1=9+av1;
		else a1=9+6-av1;
		ac2--;
		if(ac2==0){
			ac2=4;
			a2^=1;
		}
		putbmpmn(pacx/256,100,XWIDTH_PACMAN,YWIDTH_PACMAN,Pacmanbmp[a1]);
		putbmpmn(akax/256,101,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[6+a2]);
		playmusic60thsec();
		clrbmpmn(pacx/256,100,XWIDTH_PACMAN,YWIDTH_PACMAN);
		clrbmpmn(akax/256,101,XWIDTH_MONSTER,YWIDTH_MONSTER);
		pacx+=pacspeed;
		akax+=akaspeed;
	}

	for(i=0;i<20;i++){
		playmusic60thsec();
	}

	pacx=-75*256;
	akax=-15*256;
	ac1=5;
	av1=0;
	a2=0;
	ac2=4;
	pacspeed=330*256/225;
	akaspeed=300*256/225;
	while(pacx<260*256){
		ac1--;
		if(ac1==0){
			ac1=5;
			av1++;
			if(av1==6) av1=0;
		}
		if(av1<=3) a1=av1;
		else a1=6-av1;
		ac2--;
		if(ac2==0){
			ac2=4;
			a2^=1;
		}
		putbmpmn(pacx/256,83,31,31,Bigpacbmp[a1]);
		putbmpmn(akax/256,101,XWIDTH_MONSTER,YWIDTH_MONSTER,Ijikebmp[a2]);
		playmusic60thsec();
		clrbmpmn(pacx/256,83,31,31);
		clrbmpmn(akax/256,101,XWIDTH_MONSTER,YWIDTH_MONSTER);
		pacx+=pacspeed;
		akax+=akaspeed;
	}
	for(i=0;i<30;i++){
		playmusic60thsec();
	}
}
void coffeebreak2(void){
	unsigned char i;
	unsigned char a1,ac1,av1;
	unsigned char a2,ac2;
	int pacx,akax,pacspeed,akaspeed;
	clearscreen();
	pacx=255*256;
	akax=300*256;
	ac1=5;
	av1=0;
	a2=0;
	ac2=4;
	pacspeed=-290*256/245;
	akaspeed=-320*256/245;
	startmusic(musicdata2+82);
	while(akax>110*256){
		ac1--;
		if(ac1==0){
			ac1=5;
			av1++;
			if(av1==6) av1=0;
		}
		if(av1==0) a1=0;
		else if(av1<=3) a1=9+av1;
		else a1=9+6-av1;
		ac2--;
		if(ac2==0){
			ac2=4;
			a2^=1;
		}
		putbmpmn(122,111,1,4,Pinbmp);
		putbmpmn(pacx/256,100,XWIDTH_PACMAN,YWIDTH_PACMAN,Pacmanbmp[a1]);
		putbmpmn(akax/256,101,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[6+a2]);
		playmusic60thsec();
		clrbmpmn(pacx/256,100,XWIDTH_PACMAN,YWIDTH_PACMAN);
		clrbmpmn(akax/256,101,XWIDTH_MONSTER,YWIDTH_MONSTER);
		pacx+=pacspeed;
		akax+=akaspeed;
	}
	akaspeed=-9*256/80;
	while(akax>100*256){
		ac1--;
		if(ac1==0){
			ac1=5;
			av1++;
			if(av1==6) av1=0;
		}
		if(av1==0) a1=0;
		else if(av1<=3) a1=9+av1;
		else a1=9+6-av1;
		ac2--;
		if(ac2==0){
			ac2=4;
			a2^=1;
		}
		putbmpmn(pacx/256,100,XWIDTH_PACMAN,YWIDTH_PACMAN,Pacmanbmp[a1]);
		putbmpmn(akax/256,101,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[6+a2]);
		playmusic60thsec();
		clrbmpmn(pacx/256,100,XWIDTH_PACMAN,YWIDTH_PACMAN);
		clrbmpmn(akax/256,101,XWIDTH_MONSTER-1,YWIDTH_MONSTER);
		clrbmpmn(akax/256+XWIDTH_MONSTER-1,101,1,YWIDTH_MONSTER-4);
		pacx+=pacspeed;
		akax+=akaspeed;
	}
	putbmpmn(akax/256,101,22,13,Yabukebmp[0]);
	for(i=0;i<20;i++){
		playmusic60thsec();
	}
	putbmpmn(akax/256,101,22,13,Yabukebmp[1]);
	for(i=0;i<60;i++){
		playmusic60thsec();
	}
}
void coffeebreak3(void){
	unsigned char i;
	unsigned char a1,ac1,av1;
	unsigned char a2,ac2;
	int pacx,akax,pacspeed,akaspeed;
	clearscreen();
	pacx=255*256;
	akax=300*256;
	ac1=5;
	av1=0;
	a2=0;
	ac2=4;
	pacspeed=-290*256/245;
	akaspeed=-320*256/245;
	startmusic(musicdata2);
	while(akax>-20*256){
		ac1--;
		if(ac1==0){
			ac1=5;
			av1++;
			if(av1==6) av1=0;
		}
		if(av1==0) a1=0;
		else if(av1<=3) a1=9+av1;
		else a1=9+6-av1;
		ac2--;
		if(ac2==0){
			ac2=4;
			a2^=1;
		}
		putbmpmn(pacx/256,100,XWIDTH_PACMAN,YWIDTH_PACMAN,Pacmanbmp[a1]);
		putbmpmn(akax/256,101,XWIDTH_MONSTER,YWIDTH_MONSTER,Yabuke2bmp[a2]);
		playmusic60thsec();
		clrbmpmn(pacx/256,100,XWIDTH_PACMAN,YWIDTH_PACMAN);
		clrbmpmn(akax/256,101,XWIDTH_MONSTER,YWIDTH_MONSTER);
		pacx+=pacspeed;
		akax+=akaspeed;
	}

	for(i=0;i<20;i++){
		playmusic60thsec();
	}

	akax=-25*256;
	a2=0;
	ac2=4;
	akaspeed=280*256/225;
	while(akax<260*256){
		ac2--;
		if(ac2==0){
			ac2=4;
			a2^=1;
		}
		putbmpmn(akax/256,101,22,13,Hadakabmp[a2]);
		playmusic60thsec();
		clrbmpmn(akax/256,101,22,13);
		akax+=akaspeed;
	}
	for(i=0;i<30;i++){
		playmusic60thsec();
	}
}
void gamestart(void){
	unsigned int i;
	gprintstr(8*8,15*8,6,0,"READY!");
	if(gamestatus==0){ //Q[Jn
		startmusic(musicdata1);//Q[X^[g̉yJn
		for(i=0;i<120;i++){ //܂2bԉt
			playmusic60thsec();
		}
		//LN^[\čŌ܂ŉt
		player--;
		displaychars();
		displayplayers();
		while(music.stop==0){
			playmusic60thsec();
		}
	}
	else{
		displaychars();
		displayplayers();
		wait60thsec(120); //2bEFCg
	}
	gprintstr(8*8,15*8,0,0,"      "); //READY
}
void deadanim(void){
	//pbN}ꂽƂ̃Aj[VTEh
	unsigned char i,j;
	wait60thsec(120); //2bEFCg
	erasechars();
	if(fruitscoretimer>0){ //t[cHׂƂ̃XRA
		putmapchar(FRUITX-1,FRUITY);
		putmapchar(FRUITX  ,FRUITY);
		putmapchar(FRUITX+1,FRUITY);
	}

	for(i=0;i<9;i++){
		erasechars2(&pacman);
		putbmpmn_map(pacman.x/256-3,pacman.y/256-3,XWIDTH_PACMAN,YWIDTH_PACMAN,Pacmandeadbmp[i]);
		if(i>1 && i<8){
			for(j=0;j<13;j++){
				PR3=2400+(i-2)*320+(2400+(i-2)*320)*(12-j)/12;
				wait60thsec(1); // 1/60bEFCg
	 		}
	 	}
	 	else if(i==8){
			for(j=0;j<13;j++){
				PR3=1700+1700*(12-j)/12;
	 			wait60thsec(1); // 1/60bEFCg
	 		}
	 	}
	}
	erasechars2(&pacman);
	for(j=0;j<13;j++){
		PR3=1700+1700*(12-j)/12;
		wait60thsec(1); // 1/60bEFCg
	}
	PR3=0;//TEh~
}
void stageclear(void){
	//ʃNAƂ̃Aj[V
	int i;
	pacman.animvalue=0; //IɌ̂\
	pacman.animcount=pacman.animcount0;
	putpacman();
 	wait60thsec(120); //2bEFCg
	erasechars();
	if(fruitscoretimer>0){ //t[cHׂƂ̃XRA
		putmapchar(FRUITX-1,FRUITY);
		putmapchar(FRUITX  ,FRUITY);
		putmapchar(FRUITX+1,FRUITY);
	}
	putpacman();
	for(i=1;i<=6;i++){
 		wait60thsec(10); // 10/60bEFCg
		set_palette(COLOR_WALL,255,255,255); //ǂ̐F𔒂
 		wait60thsec(10); // 10/60bEFCg
		set_palette(COLOR_WALL,250,20,40); //ǂ̐F߂
	}
	switch(stage){ //R[q[uCN`FbN
		case 2:
			coffeebreak1();
			break;
		case 5:
			coffeebreak2();
			break;
		case 9:
		case 13:
		case 17:
			coffeebreak3();
	}
}
void gameover(){
	//Q[I[o[
	gprintstr(6*8,10*8,2,0,"GAME OVER");
	wait60thsec(180); // 3bEFCg
#ifdef BOOTLOADER
	if(highscore>read_recscore(0)){
		stop_composite();//\~
		write_recscore(highscore,0);//u[g[_Ήʗ̈̃R[hɃnCXRA
		start_composite();//\Jn
	}
#else
	if(highscore>*(unsigned int *)FLASHPAGE){
		stop_composite();//\~
		writehighscore();
		start_composite();//\Jn
	}
#endif
}

void scroll(){
	//1hbgXN[
	unsigned int *p;//̂32bitŃANZX
	for(p=(unsigned int *)VRAM;p<(unsigned int *)(VRAM+X_RES*(Y_RES-1));p++) *p=*(p+X_RES/4);
	for(;p<(unsigned int *)(VRAM+X_RES*Y_RES);p++) *p=0;
}
unsigned char scroll2(unsigned char n){
	//wsXN[iLN^[Pʁj
	//1hbg601b
	//X^[g{^Ă1߂
	n*=8;
	for(;n>0;n--){
		if(startkeycheck(1)) return 1;
		scroll();
	}
	return 0;
}
void title(void){
	//^Cgʕ\
	int i;
	unsigned char a1,ac1,av1;
	unsigned char a2,ac2;
	int pacx,akax,pacspeed,akaspeed;

	clearscreen();
	while(1){
		if(scroll2(3)) return;
		gprintstr(5*8,26*8,2,0,"1UP");
		gprintstr(18*8,26*8,2,0,"HI-SCORE");
		if(scroll2(1)) return;
		gprintnum2(4*8,26*8,7,0,score,6);
		gputfont(10*8,26*8,7,0,'0');
		gprintnum2(19*8,26*8,7,0,highscore,6);
		gputfont(25*8,26*8,7,0,'0');
		if(scroll2(5)) return;

		//S\
		for(i=0;i<2;i++){
			scroll();
			if(startkeycheck(1)) return;
		}
		for(i=0;i<36;i++){
			putbmpmn(67,208,114,1,Titlelogobmp[i]);
			scroll();
			if(startkeycheck(1)) return;
		}
		for(i=0;i<2;i++){
			scroll();
			if(startkeycheck(1)) return;
		}
		//S\܂

		if(scroll2(5)) return;
		gprintstr(11*8,26*8,7,0,"BY KENKEN");
		if(scroll2(1)) return;
		gprintstr(13*8,26*8,7,0,"WITH");
		if(scroll2(1)) return;
		gprintstr(0*8,26*8,7,0,"TEXT & GRAPH VIDEO OUT SYSTEM");
		if(scroll2(1)) return;
		gprintstr(8*8,26*8,7,0,"FOR PIC32MX370F");
		if(scroll2(4)) return;
		gprintstr(6*8,26*8,4,0,"PUSH START BUTTON");
		if(scroll2(1)) return;

		if(startkeycheck(600)) return;//10bEFCg

		clearscreen();
		gprintstr(5*8,2*8,2,0,"1UP");
		gprintstr(18*8,2*8,2,0,"HI-SCORE");
		gprintnum2(4*8,3*8,7,0,score,6);
		gputfont(10*8,3*8,7,0,'0');
		gprintnum2(19*8,3*8,7,0,highscore,6);
		gputfont(25*8,3*8,7,0,'0');
		gprintstr(4*8,6*8,7,0,"CHARACTER  /  NICKNAME");
		if(startkeycheck(50)) return;
		putbmpmn(3*8-3,8*8-3,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[AKABEI*8+2]);
		gprintstr(5*8,8*8,COLOR_AKABEI,0,"OIKAKE\x90\x90\x90\x90\x90\x90\x90");
		if(startkeycheck(50)) return;
		gprintstr(18*8,8*8,COLOR_AKABEI,0,"\"AKABEI\"");
		if(startkeycheck(50)) return;
		putbmpmn(3*8-3,10*8-3,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[PINKY*8+2]);
		gprintstr(5*8,10*8,COLOR_PINKY,0,"MACHIBUSE\x90\x90\x90\x90");
		if(startkeycheck(50)) return;
		gprintstr(18*8,10*8,COLOR_PINKY,0,"\"PINKY\"");
		if(startkeycheck(50)) return;
		putbmpmn(3*8-3,12*8-3,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[AOSUKE*8+2]);
		gprintstr(5*8,12*8,COLOR_AOSUKE,0,"KIMAGURE\x90\x90\x90\x90\x90");
		if(startkeycheck(50)) return;
		gprintstr(18*8,12*8,COLOR_AOSUKE,0,"\"AOSUKE\"");
		if(startkeycheck(50)) return;
		putbmpmn(3*8-3,14*8-3,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[GUZUTA*8+2]);
		gprintstr(5*8,14*8,COLOR_GUZUTA,0,"OTOBOKE\x90\x90\x90\x90\x90\x90");
		if(startkeycheck(50)) return;
		gprintstr(18*8,14*8,COLOR_GUZUTA,0,"\"GUZUTA\"");
		if(startkeycheck(50)) return;
		gputfont(11*8,21*8,COLOR_COOKIE,0,CODE_COOKIE);
		gprintstr(13*8,21*8,7,0,"10 PTS");
		gputfont(11*8,22*8,COLOR_COOKIE,0,CODE_POWERCOOKIE);
		gprintstr(13*8,22*8,7,0,"50 PTS");
		gprintstr(6*8,25*8,4,0,"PUSH START BUTTON");

		gamecount=0;
		pacx=255*256;
		akax=280*256;
		ac1=5;
		av1=0;
		a2=0;
		ac2=4;
		pacspeed=-200;
		akaspeed=-200;
		while(pacx>46*256){
			ac1--;
			if(ac1==0){
				ac1=5;
				av1++;
				if(av1==6) av1=0;
			}
			if(av1==0) a1=0;
			else if(av1<=3) a1=9+av1;
			else a1=9+6-av1;
			ac2--;
			if(ac2==0){
				ac2=4;
				a2^=1;
			}
			gputfont(6*8,17*8,COLOR_POWERCOOKIE,0,CODE_POWERCOOKIE);
			putbmpmn(pacx/256,133,XWIDTH_PACMAN,YWIDTH_PACMAN,Pacmanbmp[a1]);
			putbmpmn(akax/256,134,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[AKABEI*8+6+a2]);
			putbmpmn(akax/256+18,134,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[PINKY*8+6+a2]);
			putbmpmn(akax/256+36,134,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[AOSUKE*8+6+a2]);
			putbmpmn(akax/256+54,134,XWIDTH_MONSTER,YWIDTH_MONSTER,Monsterbmp[GUZUTA*8+6+a2]);
			if(startkeycheck(1)) return;
			clrbmpmn(pacx/256,133,XWIDTH_PACMAN,YWIDTH_PACMAN);
			clrbmpmn(akax/256,134,XWIDTH_MONSTER+54,YWIDTH_MONSTER);
			pacx+=pacspeed;
			akax+=akaspeed;
			gamecount++;
			blinkpowercookie();
		}
		pacspeed=-pacspeed;
		akaspeed=100;
		i=0;
		while(i<4){
			ac1--;
			if(ac1==0){
				ac1=5;
				av1++;
				if(av1==6) av1=0;
			}
			if(av1==0) a1=0;
			else if(av1<=3) a1=3+av1;
			else a1=3+6-av1;
			ac2--;
			if(ac2==0){
				ac2=4;
				a2^=1;
			}
			if(i<=0) putbmpmn(akax/256,134,XWIDTH_MONSTER,YWIDTH_MONSTER,Ijikebmp[a2]);
			if(i<=1) putbmpmn(akax/256+18,134,XWIDTH_MONSTER,YWIDTH_MONSTER,Ijikebmp[a2]);
			if(i<=2) putbmpmn(akax/256+36,134,XWIDTH_MONSTER,YWIDTH_MONSTER,Ijikebmp[a2]);
			if(i<=3) putbmpmn(akax/256+54,134,XWIDTH_MONSTER,YWIDTH_MONSTER,Ijikebmp[a2]);
			putbmpmn(pacx/256,133,XWIDTH_PACMAN,YWIDTH_PACMAN,Pacmanbmp[a1]);
			if(startkeycheck(1)) return;
			clrbmpmn(pacx/256,133,XWIDTH_PACMAN,YWIDTH_PACMAN);
			switch(i){
				case 0:
					if(pacx/256>akax/256-6){
						i++;
						clrbmpmn(akax/256,134,XWIDTH_MONSTER,YWIDTH_MONSTER);
						putbmpmn(pacx/256,136,XWIDTH_SCORE,YWIDTH_SCORE,Scorebmp[0]);
						if(startkeycheck(30)) return;
					}
					break;
				case 1:
					if(pacx/256>akax/256+18-6){
						i++;
						clrbmpmn(akax/256+18,134,XWIDTH_MONSTER,YWIDTH_MONSTER);
						putbmpmn(pacx/256,136,XWIDTH_SCORE,YWIDTH_SCORE,Scorebmp[1]);
						if(startkeycheck(30)) return;
					}
					break;
				case 2:
					if(pacx/256>akax/256+36-6){
						i++;
						clrbmpmn(akax/256+36,134,XWIDTH_MONSTER,YWIDTH_MONSTER);
						putbmpmn(pacx/256,136,XWIDTH_SCORE,YWIDTH_SCORE,Scorebmp[2]);
						if(startkeycheck(30)) return;
					}
					break;
				case 3:
					if(pacx/256>akax/256+54-6){
						i++;
						clrbmpmn(akax/256+54,134,XWIDTH_MONSTER,YWIDTH_MONSTER);
						putbmpmn(pacx/256,136,XWIDTH_SCORE,YWIDTH_SCORE,Scorebmp[3]);
						if(startkeycheck(30)) return;
					}
			}
			clrbmpmn(akax/256,134,XWIDTH_MONSTER+54,YWIDTH_MONSTER);
			pacx+=pacspeed;
			akax+=akaspeed;
		}
	}
}
void game(void){
	gameinit2();//XRAȂǏ
	gamestatus=0;//0:Q[X^[gA1:Q[A2:vC[1A3:Xe[WNAA4:Q[I[o[
	while(gamestatus<4){
		gameinit3();//V[NAAʘH\
		if(gamestatus==3) gamestatus=1;
		while(gamestatus<3){
			gamecount=0;//S̃JE^[
			gameinit4();//pbN}AX^[ʒuȂ
			gamestart();//Ready!\
			gamestatus=1;
			drawcount=0;
			while(gamestatus==1){
				while(drawcount==0) asm("wait");//AChɂĊ荞ݑ҂
				drawcount=0;
				gamecount++;
				sound();		//ʉo
				erasechars();	//LN^[\
				keycheck();		//{^`FbN
				movechars();	//LN^[ړ
				displaychars();	//LN^[\
				fruitcheck();	//t[c֌W`FbN
				huntedcheck();	//HAHꂽ`FbN
				displayscore();	//XRA\
				pausecheck();	//ꎞ~{^`FbN
			}
			PR3=0;//TEh~
			set_palette(COLOR_POWERCOOKIE,0,255,255);//p[̐FWɖ߂
			if(gamestatus==2){
				deadanim(); //pbN}ꂽ̃Aj[V
				if(player==0) gamestatus=4;//Q[I[o[
				else player--;
			}
			else if(gamestatus==3){
				//Xe[WNA
				stageclear(); //Xe[WNAAj[VAR[q[uCN
			}
		}
	}
	gameover(); //Q[I
}

int main(void){
	/* |[g̏ݒ */
	TRISB = 0x0000;						// Sďo
	TRISC = 0x0000;						// Sďo
	TRISD = KEYSTART | KEYFIRE | KEYUP | KEYDOWN | KEYLEFT | KEYRIGHT;// {^ڑ|[g͐ݒ
	TRISE = 0x0000;						// Sďo
	TRISF = 0x0003;						// RF0,1͓
	TRISG = 0x0080;						// RG7͓
	ANSELD = 0x0000; // SăfW^
	ANSELG = 0x0000; // SăfW^
	CNPUDSET=KEYSTART | KEYFIRE | KEYUP | KEYDOWN | KEYLEFT | KEYRIGHT;// vAbvݒ

	SDI2R = 1;						//RPG7SDI2蓖
	RPG8R = 6;						//RPG8SDO2蓖

	//TEh֌Wݒ
	RPF5R = 0x0b; //RPF5OC4蓖
	OC4R=0;
	OC4CON=0x800b;// Tiemr3x[XAToggle[hŗL
	PR3=0;// Timer3
	T3CON=0x8040;// vXP[1:16Timer3Jn

#ifdef BOOTLOADER
	init_recscore();//u[g[_Ή̋LnCXRAL^̈AR[hȂΐVK쐬
	if(read_recscore(0)==0xffffffff){
		highscore=1000;
		write_recscore(highscore,0);//nCXRAl10000_
	}
	else highscore=read_recscore(0); //u[g[_Ήʗ̈悩烌R[h1ڂ32rbgǂݏo
#else
	if(*(unsigned int *)FLASHPAGE==-1){ //tbVɃnCXRA܂Ă邩`FbN
		highscore=1000;
		writehighscore();
	}
	else highscore=*(unsigned int *)FLASHPAGE;
#endif

	init_composite(); // rfINAA荞ݏAJ[rfIo͊Jn

	gameinit(); //Q[S̏
	while(1){
		title();//^CgʁAX^[g{^Ŗ߂
		game();//Q[C[v
	}
}
