//PACMAN for PIC32MX370F512H by K.Tanaka
// With Color Text+Graph Video Out System

#define BOOTLOADER //u[g[_[pAPɂꍇLɂ

//u[g[_[gp͋ʃnCXRAݗ̈𗘗p
//gp̓tbVŌ̃y[WɃnCXRAL^
#ifndef BOOTLOADER
//nCXRA݃y[Wi4096oCgPʂŏj
#define FLASHPAGE (0x9d080000-0x1000)
#endif

// ̓{^̃|[gArbg`
#define KEYPORT PORTD
#define KEYDOWN 0x0001
#define KEYLEFT 0x0002
#define KEYUP 0x0004
#define KEYRIGHT 0x0008
#define KEYSTART 0x0010
#define KEYFIRE 0x0020

//@̒l
#define DIR_UP 0
#define DIR_RIGHT 1
#define DIR_DOWN 2
#define DIR_LEFT 3

//el̒`
#define MAPXSIZE 21 //ʘH̉TCY
#define MAPYSIZE 27 //ʘH̏cTCY
#define STAGEMAX 21 //f[^`ꂽXe[W̍őAȍ~͓ěJԂ
#define FRUITTIME1 130 //eXe[W1ڃt[co̎c肦
#define FRUITTIME2 55 //eXe[W2ڃt[co̎c肦
#define FRUITX 10 //t[c\ʒuX
#define FRUITY 15 //t[c\ʒuY
#define MONSTERHOUSEX 10 //X^[nEXXW
#define MONSTERHOUSEY 12 //X^[nEXYW
#define NAWABARIAKABEIX 15 //AJxC̓꒣ڕWX
#define NAWABARIAKABEIY 3 //AJxC̓꒣ڕWY
#define NAWABARIPINKYX 1 //sL[̓꒣ڕWX
#define NAWABARIPINKYY 3 //sL[̓꒣ڕWY
#define NAWABARIAOSUKEX 17 //AIXP̓꒣ڕWX
#define NAWABARIAOSUKEY 18 //AIXP̓꒣ڕWY
#define NAWABARIGUZUTAX 3 //OY^̓꒣ڕWX
#define NAWABARIGUZUTAY 21 //OY^̓꒣ڕWY
#define ONEWAY1X 9 //ʍs1XW
#define ONEWAY1Y 9 //ʍs1YW
#define ONEWAY2X 11 //ʍs2XW
#define ONEWAY2Y 9 //ʍs2YW
#define ONEWAY3X 9 //ʍs3XW
#define ONEWAY3Y 19 //ʍs3YW
#define ONEWAY4X 11 //ʍs4XW
#define ONEWAY4Y 19 //ʍs4YW
#define WARPX1 4 //[v][XW1
#define WARPX2 16 //[v][XW2
#define WARPY 13 //[v][YW

#define XWIDTH_PACMAN 14
#define YWIDTH_PACMAN 14
#define XWIDTH_MONSTER 14
#define YWIDTH_MONSTER 13
#define XWIDTH_SCORE 16
#define YWIDTH_SCORE 7

//eLN^[R[h`
#define CODE_WALL1 0x80
#define CODE_WALL2 0x8d
#define CODE_COOKIE 0x90
#define CODE_POWERCOOKIE 0x91
#define CODE_DOOR 0x8e

//}bvz̔zu`
#define MAP_NONE 0 //Ȃ
#define MAP_WALL 1 //
#define MAP_COOKIE 2 //
#define MAP_POWERCOOKIE 3 //p[
#define MAP_FRUIT 4 //t[c
#define MAP_DOOR 5 //hA

//J[`
#define COLOR_WALL 11
#define COLOR_COOKIE 6
#define COLOR_POWERCOOKIE 13
#define COLOR_DOOR 7
#define COLOR_PACMAN 6
#define COLOR_AKABEI 2
#define COLOR_PINKY 10
#define COLOR_AOSUKE 5
#define COLOR_GUZUTA 9
#define COLOR_ORANGE 12
#define COLOR_MONSTERNUDE 14

// e펞Ԓݒ
#define TIMER_OIKAKE 1200 //ǂ[h
#define TIMER_NAWABARI 600 //꒣胂[h
#define TIMER_FRUIT 600 //t[c\
#define TIMER_HUNTEDSTOP 60 //CWPHƂ̒~
#define TIMER_FRUITSCORE 120 //t[c̃XRA\

// X^[̃[histatusj
#define NAWABARI 1
#define OIKAKE 2
#define IJIKE 3
#define MEDAMA 4
#define TAIKI 5
#define TAIKI2 6

// X^[ԍ
#define AKABEI 0
#define AOSUKE 1
#define GUZUTA 2
#define PINKY 3

//_Character\̒`
//pbN}AX^[4C̃IuWFNg
typedef struct {
	unsigned short x; // xWi8rbg͏_ȉj
	unsigned short y; // yWi8rbg͏_ȉj
	unsigned short oldx; // OxWi8rbg͏_ȉj
	unsigned short oldy; // OyWi8rbg͏_ȉj
	unsigned short speed; // ړx
	unsigned char no; // X^[̔ԍ
	unsigned char status; // ݂̃[h
	unsigned char dir; // ړ 0:A1:EA2:A3:
	unsigned char turn; // ύXtOA_ȏ̈ړ܂ŃNAȂ
	unsigned char animvalue; // Aj[Vl
	unsigned char animcount; // Aj[VJE^[A炵Ă0ɂȂAj[VlXV
	unsigned char animcount0; // Aj[VJE^[l
	unsigned short modecount; // ݂̃[h̃JE^[
} _Character;

//_Music\̒`
typedef struct {
	unsigned char *p; //Ȕz̉ẗʒu
	unsigned char count; //̉JE^
	unsigned char stop; //0:tA1:I
} _Music;

extern const unsigned char GFontData[]; //tHgp^[`
extern const unsigned char Pacmanbmp[][14*14]; //pbN}rbg}bv
extern const unsigned char Pacmandeadbmp[][14*14]; //pbN}rbg}bv
extern const unsigned char Monsterbmp[][14*13]; //X^[rbg}bv
extern const unsigned char Ijikebmp[][14*13]; //CWPrbg}bv
extern const unsigned char Medamabmp[][14*13]; //ڋʃrbg}bv
extern const unsigned char Fruitbmp[][12*14]; //t[crbg}bv
extern const unsigned char Scorebmp[][16*7]; //XRArbg}bv
extern const unsigned char Bigpacbmp[][31*31]; //pbN}rbg}bv
extern const unsigned char Pinbmp[]; //srbg}bv
extern const unsigned char Yabukebmp[][22*13]; //jX^[rbg}bv
extern const unsigned char Yabuke2bmp[][14*13]; //jX^[2rbg}bv
extern const unsigned char Hadakabmp[][22*13]; //X^[rbg}bv
extern const unsigned char Titlelogobmp[][114]; //^CgSrbg}bv
