//TETRIS for PIC32MX370F512H by K.Tanaka
// With Color Text+Graph Video Out System

#define BOOTLOADER //u[g[_[pAPɂꍇLɂ

//u[g[_[gp͋ʃnCXRAݗ̈𗘗p
//gp̓tbVŌ̃y[WɃnCXRAL^
#ifndef BOOTLOADER
//nCXRA݃y[Wi4096oCgPʂŏj
#define FLASHPAGE (0x9d080000-0x1000)
#endif

// ̓{^̃|[gArbg`
#define KEYPORT PORTD
#define KEYDOWN 0x0001
#define KEYLEFT 0x0002
#define KEYUP 0x0004
#define KEYRIGHT 0x0008
#define KEYSTART 0x0010
#define KEYFIRE 0x0020

#define SCENECLEARLINE 20 //Xe[WNȀC

//eLN^[R[h`
#define CODE_BLOCK 0x01
#define CODE_WALL 0x02
#define CODE_BRICK 0x03
#define CODE_SPACE 0
#define CODE_CLEARBLOCK 0x61

//J[`
#define COLOR_IBLOCK 2
#define COLOR_JBLOCK 1
#define COLOR_LBLOCK 8
#define COLOR_ZBLOCK 4
#define COLOR_SBLOCK 3
#define COLOR_OBLOCK 6
#define COLOR_TBLOCK 5
#define COLOR_WALL 9
#define COLOR_BITMAP 10
#define COLOR_BRICK 11
#define COLOR_FRAME 4
#define COLOR_SPACE 0
#define COLOR_CLEARBLOCK 7

#define SOUNDDONGLENGTH 7

//_Block\̒`
typedef struct {
	//eubN̈ʒúA(0,0)Ǝc3̑ΈʒuŒ`
	char x1,y1;
	char x2,y2;
	char x3,y3;
	char color;//F
	char rot; //]\񐔁AzƏʒuɖ߂
} _Block;

//_Music\̒`
typedef struct {
	unsigned char *p; //Ȕz̉ẗʒu
	unsigned char *startp; //Ȕz̃s[gʒu
	unsigned char count; //̉JE^
	unsigned short pr; //̉i^C}j
	unsigned char stop; //0:tA1:I
} _Music;
