// veludda.h by K.Tanaka

#define BOOTLOADER //u[g[_[pAPɂꍇLɂ

//u[g[_[gp͋ʃnCXRAݗ̈𗘗p
//gp̓tbVŌ̃y[WɃnCXRAL^
#ifndef BOOTLOADER
//nCXRA݃y[Wi4096oCgPʂŏj
#define FLASHPAGE (0x9d080000-0x1000)
#endif

// ̓{^̃|[gArbg`
#define KEYPORT PORTD
#define KEYDOWN 0x0001
#define KEYLEFT 0x0002
#define KEYUP 0x0004
#define KEYRIGHT 0x0008
#define KEYSTART 0x0010
#define KEYFIRE 0x0020

#define MAPDX (256*4) //S̃}bv̉TCYirbg}bvf[^41̂݁j
#define MAPDY (128*4) //S̃}bv̏cTCYirbg}bvf[^41̂݁j
#define NORMALIZEX(x) ((x)&(MAPDX*256-1)) //΍W̉E[͂ݏo[̈ʒuɂ}N
#define NORMALIZEY(y) ((y)&(MAPDY*256-1)) //΍W̉[͂ݏo[̈ʒuɂ}N
//#define MAPDXMASK (MAPDX*256-1) //΍W̉E[͂ݏo[ɂ邽߂̃}XNl
//#define MAPDYMASK (MAPDY*256-1) //΍W̉[͂ݏo[ɂ邽߂̃}XNl
#define ADX1 (128/4*3) //@Xʒuʍ[܂ł̋
#define ADY1 (180/4*3) //@Yʒuʏ[܂ł̋
#define ADX2 (X_RES/4*3-ADX1) //@XʒuʉE[܂ł̋
#define ADY2 ((Y_RES-TOPLINE)/4*3-ADY1) //@Yʒuʉ[܂ł̋

#define MAX_GNDENEMY 50 //nGő吔
#define MAX_ENEMY 50 //󒆓Gő吔
#define MAX_MISSILE 20 //~TCő吔
#define MAX_CANNON 5 //Ceő吔

#define XSIZE_GNDENEMY 14 //nG摜TCY
#define YSIZE_GNDENEMY 14 //nG摜cTCY
#define SQSIZE_GNDENEMY (XSIZE_GNDENEMY*YSIZE_GNDENEMY)
#define XSIZE_ENEMY 12 //󒆓G摜TCY
#define YSIZE_ENEMY 12 //󒆓G摜cTCY
#define SQSIZE_ENEMY (XSIZE_ENEMY*YSIZE_ENEMY)
#define XSIZE_SHIP 16 //@摜TCY
#define YSIZE_SHIP 16 //@摜cTCY
#define SQSIZE_SHIP (XSIZE_SHIP*YSIZE_SHIP)
#define XSIZE_EXPLODE 12 //G摜TCY
#define YSIZE_EXPLODE 12 //G摜cTCY
#define SQSIZE_EXPLODE (XSIZE_EXPLODE*YSIZE_EXPLODE)
#define XSIZE_EXPLODE2 16 //@摜TCY
#define YSIZE_EXPLODE2 16 //@摜cTCY
#define SQSIZE_EXPLODE2 (XSIZE_EXPLODE2*YSIZE_EXPLODE2)
#define XSIZE_MISSILE 4 //~TC摜TCY
#define YSIZE_MISSILE 4 //~TC摜cTCY
#define SQSIZE_MISSILE (XSIZE_MISSILE*YSIZE_MISSILE)
#define XSIZE_CANNON 8 //Ce摜TCY
#define YSIZE_CANNON 8 //Ce摜cTCY
#define SQSIZE_CANNON (XSIZE_CANNON*YSIZE_CANNON)
#define XSIZE_LOGO 209 //^CgS摜TCY
#define YSIZE_LOGO 33 //^CgS摜cTCY

#define SHIPS 5 //@̏c
#define CANNONFIRE 80 //Ce˔f
#define CONTINUEMAX 3 //ReBj[\

//󒆓GAnGp\̒`
typedef struct {
	char on; // L^^
	int x; // xW*256
	int y; // yW*256
	short vx; // xړx*256
	short vy; // yړx*256
	unsigned char no; // Gԍ
	unsigned char count; // JE^
	const unsigned char *bmp; // 摜ւ̃|C^
} _Enemy;

//~TCACep\̒`
typedef struct {
	char on; // L^
	int x; // xW*256
	int y; // yW*256
	short vx; // xړx*256
	short vy; // yړx*256
	unsigned char count; // JE^
	const unsigned char *bmp; // 摜ւ̃|C^
} _Missile;

//Oϐ錾
extern const unsigned char Bmp_ship[];
extern const unsigned char Bmp_gndenemy[][SQSIZE_GNDENEMY];
extern const unsigned char Bmp_enemy[][SQSIZE_ENEMY];
extern const unsigned char Bmp_explode[][SQSIZE_EXPLODE];
extern const unsigned char Bmp_explode2[][SQSIZE_EXPLODE2];
extern const unsigned char Bmp_missile1[SQSIZE_MISSILE];
extern const unsigned char Bmp_missile2[SQSIZE_MISSILE];
extern const unsigned char Bmp_cannon[][SQSIZE_CANNON];
extern const unsigned char Bmp_ship_mini[];
extern const unsigned char Bmp_enemy_mini[];
extern const unsigned char Bmp_logo[];

extern unsigned char mapdata[],paldata2[];//}bvf[^ƃpbgf[^

extern const unsigned short sounddata[];//f[^
extern const unsigned short sounddata1[],sounddata2[],sounddata3[];//ʉf[^
extern const unsigned char musicdata1[],musicdata2[],musicdata3[],musicdata4[];//ȃf[^
