// textvideo370fmini.c
// PIC32MX370F512Hu[g[_eLXgrfIo̓vO@by K.Tanaka
// o PORTEiRE0-4j
// eLXg𑜓x 8~8hbgA30~27
// J[pbgΉ
// NbNg3.579545MHz~4~20/3{
// 1hbgJ[TuLA43i20NbNj
// 1hbg4MóiJ[TuLA1316ój

#include "textvideo370fmini.h"
#include <plib.h>

//J[Mo̓f[^
//
#define C_SYN	0
#define C_BLK	7

#define C_BST1	7
#define C_BST2	5
#define C_BST3	4
#define C_BST4	6
#define C_BST5	10
#define C_BST6	11
#define C_BST7	10
#define C_BST8	6
#define C_BST9	4
#define C_BST10	5
#define C_BST11	7
#define C_BST12	10
#define C_BST13	11
#define C_BST14	9
#define C_BST15	5
#define C_BST16	4
#define C_BST17	5
#define C_BST18	9
#define C_BST19	11
#define C_BST20	10

// pX萔
#define V_NTSC		262				// 262{/
#define V_SYNC		10				// {
#define V_PREEQ		22				// uLOԏ㑤
#define V_LINE		(WIDTH_Y*8)			// 摜`
#define H_NTSC		6080				// 1C̃NbNi63.563.7secjiFg228j
#define H_SYNC		449				// A4.7sec

#define nop()	asm volatile("nop")
#define nop5()	nop();nop();nop();nop();nop();
#define nop10()	nop5();nop5();

// O[oϐ`
unsigned char TVRAM[WIDTH_X*WIDTH_Y*2+1] __attribute__ ((aligned (4))); //TextVRAM
unsigned char *TVRAMp; //TVRAMAhX
unsigned char FontRAM[8*256] __attribute__((aligned (4))); //FontData珉ɃRs[
const unsigned char *Fontp; //sFontRAM̐擪AhX

volatile unsigned short LineCount;	// ̍s
volatile unsigned short drawcount;	//@1ʕ\IƂ1BAv0ɂB
					// Œ1͉ʕ\Ƃ̃`FbNƁAAv̏ʊԕKv̊mFɗpB
volatile char drawing;		//@fԏ-1Ȃ0


//J[Mg`e[u
//256F̃J[pbg
//163Pʂ3
unsigned char ClTable[16*256] __attribute__ ((aligned (4)));


/**********************
*  Timer2 荞ݏ֐
***********************/
void __ISR(8, ipl5) T2Handler(void)
{
	asm volatile("#":::"a0");
	asm volatile("#":::"v0");

	//TMR2̒lŃ^C~Ô␳
	asm volatile("la	$v0,%0"::"i"(&TMR2));
	asm volatile("lhu	$a0,0($v0)");
	asm volatile("addiu	$a0,$a0,-23");
	asm volatile("bltz	$a0,label1_2");
	asm volatile("addiu	$v0,$a0,-18");
	asm volatile("bgtz	$v0,label1_2");
	asm volatile("sll	$a0,$a0,2");
	asm volatile("la	$v0,label1");
	asm volatile("addu	$a0,$v0");
	asm volatile("jr	$a0");
asm volatile("label1:");
	nop10();nop10();nop();nop();

asm volatile("label1_2:");
	//LATE=C_SYN;
	asm volatile("addiu	$a0,$zero,%0"::"n"(C_SYN));
	asm volatile("la	$v0,%0"::"i"(&LATE));
	asm volatile("sb	$a0,0($v0)");// MBɑSĂ̐Mo͂̃^C~O𒲐

	if(LineCount<V_SYNC){
		// 
		OC3R = H_NTSC-H_SYNC-1;	// ؂荞݃pXݒ
		OC3CON = 0x8001;
	}
	else{
		OC1R = H_SYNC-1-20;		// pX4.7usec
		OC1CON = 0x8001;		// ^C}2IVbg
		if(LineCount>=V_SYNC+V_PREEQ && LineCount<V_SYNC+V_PREEQ+V_LINE){
			drawing=-1; // 摜`
		}
	}
	LineCount++;
	if(LineCount>=V_NTSC) LineCount=0;
	mT2ClearIntFlag();			// T2荞݃tONA
}

/*********************
*  OC3荞ݏ֐ ؂荞݃pX
*********************/
void __ISR(14, ipl5) OC3Handler(void)
{
	asm volatile("#":::"v0");
	asm volatile("#":::"v1");
	asm volatile("#":::"a0");

	//TMR2̒lŃ^C~Ô␳
	asm volatile("la	$v0,%0"::"i"(&TMR2));
	asm volatile("lhu	$a0,0($v0)");
	asm volatile("addiu	$a0,$a0,%0"::"n"(-(H_NTSC-H_SYNC+23)));
	asm volatile("bltz	$a0,label4_2");
	asm volatile("addiu	$v0,$a0,-18");
	asm volatile("bgtz	$v0,label4_2");
	asm volatile("sll	$a0,$a0,2");
	asm volatile("la	$v0,label4");
	asm volatile("addu	$a0,$v0");
	asm volatile("jr	$a0");

asm volatile("label4:");
	nop10();nop10();nop();nop();

asm volatile("label4_2:");
	// M̃Zbg
	//	LATE=C_BLK;
	asm volatile("addiu	$v1,$zero,%0"::"n"(C_BLK));
	asm volatile("la	$v0,%0"::"i"(&LATE));
	asm volatile("sb	$v1,0($v0)");	// MZbgBM肩5631TCN

	mOC3ClearIntFlag();			// OC3荞݃tONA
}

/*********************
*  OC1荞ݏ֐ オ--J[o[Xg--fM
*********************/
// [vgpăvOTCY邽߁ARAMŎs
// RAM̃f[^ǂݏo1NbNx̂Œ
void __ISR(6, ipl5) __longramfunc__ OC1Handler(void)
{
	asm volatile("#":::"v0");
	asm volatile("#":::"v1");
	asm volatile("#":::"a0");
	asm volatile("#":::"a1");
	asm volatile("#":::"a2");
	asm volatile("#":::"t0");
	asm volatile("#":::"t1");
	asm volatile("#":::"t2");
	asm volatile("#":::"t3");
	asm volatile("#":::"t4");
	asm volatile("#":::"t5");

	//TMR2̒lŃ^C~Ô␳
	asm volatile("la	$v0,%0"::"i"(&TMR2));
	asm volatile("lhu	$a0,0($v0)");
	asm volatile("addiu	$a0,$a0,%0"::"n"(-(H_SYNC+23+4)));
	asm volatile("bltz	$a0,label2_2");
	asm volatile("addiu	$v0,$a0,-18");
	asm volatile("bgtz	$v0,label2_2");
	asm volatile("sll	$a0,$a0,2");
	asm volatile("la	$v0,label2");
	asm volatile("addu	$a0,$v0");
	asm volatile("jr	$a0");

asm volatile("label2:");
	nop10();nop10();nop();nop();

asm volatile("label2_2:");
	// M̃Zbg
	//	LATE=C_BLK;
	asm volatile("addiu	$v1,$zero,%0"::"n"(C_BLK));
	asm volatile("la	$v0,%0"::"i"(&LATE));
	asm volatile("sb	$v1,0($v0)");	// MZbgB肩449TCN

	// 54NbNEFCg
//	nop10();nop10();nop10();nop10();nop10();nop();nop();nop();nop();
	asm volatile("addiu	$v1,$zero,17");
asm volatile("label_noploop1:");
	asm volatile("addiu	$v1,$v1,-1");
	nop();
	asm volatile("bnez	$v1,label_noploop1");
	nop();

	asm volatile("addiu	$a0,$zero,3");//[vJE^
	// J[o[XgM 9o
	asm volatile("la	$v0,%0"::"i"(&LATE));
	asm volatile("addiu	$v1,$zero,%0"::"n"(C_BST1));

asm volatile("label_loop2:");
	asm volatile("sb	$v1,0($v0)");	// J[o[XgJnB肩507TCN
	asm volatile("addiu	$v1,$zero,%0"::"n"(C_BST2));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST3));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST4));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST5));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST6));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST7));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST8));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST9));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST10));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST11));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST12));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST13));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST14));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST15));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST16));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST17));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST18));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST19));nop();nop();
	asm volatile("sb $v1,0($v0)");asm volatile("addiu $v1,$zero,%0"::"n"(C_BST20));nop();nop();
	asm volatile("sb	$v1,0($v0)");
	asm volatile("addiu	$a0,$a0,-1");
	asm volatile("addiu	$v1,$zero,%0"::"n"(C_BST1));
	asm volatile("bnez	$a0,label_loop2");

	asm volatile("sb	$v1,0($v0)");	// J[o[XgIB肩747TCN


	//	if(drawing==0) goto label3;  //fԂłȂΏI
	asm volatile("la	$v0,%0"::"i"(&drawing));
	asm volatile("lb	$t1,0($v0)");
	asm volatile("beqz	$t1,label3");
	nop();

	// 206NbNEFCg
	asm volatile("addiu	$v1,$zero,68");
asm volatile("label_noploop2:");
	asm volatile("addiu	$v1,$v1,-1");
	nop();
	asm volatile("bnez	$v1,label_noploop2");
	nop();
/*
	nop10();nop10();nop10();nop10();nop10();nop10();nop10();nop10();nop10();nop10();
	nop10();nop10();nop10();nop10();nop10();nop10();nop10();nop10();nop10();nop10();
	nop5();nop();
*/

// fMo

	//	a1=ClTable;
	asm volatile("la	$a1,%0"::"i"(ClTable));
	//	a2=&LATE;
	asm volatile("la	$a2,%0"::"i"(&LATE));

	//	a0=TVRAMp;
	asm volatile("la	$t0,%0"::"i"(&TVRAMp));
	asm volatile("lw	$a0,0($t0)");

	//	t4=Fontp;
	asm volatile("la	$t0,%0"::"i"(&Fontp));
	asm volatile("lw	$t4,0($t0)");

	asm volatile("lbu	$t5,0($a0)");
	asm volatile("lbu	$t3,%0($a0)"::"n"(ATTROFFSET));
	asm volatile("addiu	$a0,$a0,1");
	asm volatile("sll	$t5,$t5,3");
	asm volatile("addu	$t5,$t5,$t4");
	asm volatile("lbu	$t2,0($t5)");

	asm volatile("and	$v1,$v1,$zero");
	asm volatile("ext	$t0,$t2,7,1");	//ext t0,t2,n,1 n:7,6,5,4,3,2,1,0,7,6...
	asm volatile("movn	$v1,$t3,$t0");
	asm volatile("sll	$v1,$v1,4");
	asm volatile("addu	$v1,$v1,$a1");
	asm volatile("lw	$t1,0($v1)");	//lw t1,n(v1) n:0,4,8,12,0,4...
	asm volatile("addiu	$v0,$zero,30"); //loop counter

//----------------------------------------------------------------------
asm volatile("label_loop1:");
	asm volatile("sb	$t1,0($a2)");	//ŏ̉fMóB肩987TCN
	asm volatile("rotr	$t1,$t1,8");
		asm volatile("and	$v1,$v1,$zero");
		asm volatile("ext	$t0,$t2,6,1");	//ext t0,t2,n,1 n:7,6,5,4,3,2,1,0,7,6...
		asm volatile("movn	$v1,$t3,$t0");
	asm volatile("sb	$t1,0($a2)");
	asm volatile("rotr	$t1,$t1,8");
		asm volatile("sll	$v1,$v1,4");
		asm volatile("addu	$v1,$v1,$a1");
	nop();
	asm volatile("sb	$t1,0($a2)");
	asm volatile("rotr	$t1,$t1,8");
	nop();
	nop();
	nop();
	asm volatile("sb	$t1,0($a2)");
	nop();
	nop();
		asm volatile("lw	$t1,4($v1)");	//lw t1,n(v1) n:0,4,8,12,0,4...
		asm volatile("sb	$t1,0($a2)");	//hbgŏ̏o
		asm volatile("rotr	$t1,$t1,8");
	asm volatile("and	$v1,$v1,$zero");
	asm volatile("ext	$t0,$t2,5,1");	//ext t0,t2,n,1 n:7,6,5,4,3,2,1,0,7,6...
	asm volatile("movn	$v1,$t3,$t0");
		asm volatile("sb	$t1,0($a2)");
		asm volatile("rotr	$t1,$t1,8");
	asm volatile("sll	$v1,$v1,4");
	asm volatile("addu	$v1,$v1,$a1");
	nop();
		asm volatile("sb	$t1,0($a2)");
		asm volatile("rotr	$t1,$t1,8");
	nop();
	nop();
	nop();
		asm volatile("sb	$t1,0($a2)");
	nop();
	nop();
	asm volatile("lw	$t1,8($v1)");	//lw t1,n(v1) n:0,4,8,12,0,4...
	asm volatile("sb	$t1,0($a2)");	//hbgŏ̏o
	asm volatile("rotr	$t1,$t1,8");
		asm volatile("and	$v1,$v1,$zero");
		asm volatile("ext	$t0,$t2,4,1");	//ext t0,t2,n,1 n:7,6,5,4,3,2,1,0,7,6...
		asm volatile("movn	$v1,$t3,$t0");
	asm volatile("sb	$t1,0($a2)");
	asm volatile("rotr	$t1,$t1,8");
		asm volatile("sll	$v1,$v1,4");
		asm volatile("addu	$v1,$v1,$a1");
	nop();
	asm volatile("sb	$t1,0($a2)");
	asm volatile("rotr	$t1,$t1,8");
	nop();
	nop();
	nop();
	asm volatile("sb	$t1,0($a2)");
	nop();
	nop();
		asm volatile("lw	$t1,12($v1)");	//lw t1,n(v1) n:0,4,8,12,0,4...
		asm volatile("sb	$t1,0($a2)");	//hbgŏ̏o
		asm volatile("rotr	$t1,$t1,8");
	asm volatile("and	$v1,$v1,$zero");
	asm volatile("ext	$t0,$t2,3,1");	//ext t0,t2,n,1 n:7,6,5,4,3,2,1,0,7,6...
	asm volatile("movn	$v1,$t3,$t0");
		asm volatile("sb	$t1,0($a2)");
		asm volatile("rotr	$t1,$t1,8");
	asm volatile("sll	$v1,$v1,4");
	asm volatile("addu	$v1,$v1,$a1");
	nop();
		asm volatile("sb	$t1,0($a2)");
		asm volatile("rotr	$t1,$t1,8");
	nop();
	nop();
	nop();
		asm volatile("sb	$t1,0($a2)");
	nop();
	nop();
	asm volatile("lw	$t1,0($v1)");	//lw t1,n(v1) n:0,4,8,12,0,4...
	asm volatile("sb	$t1,0($a2)");	//hbgŏ̏o
	asm volatile("rotr	$t1,$t1,8");
		asm volatile("and	$v1,$v1,$zero");
		asm volatile("ext	$t0,$t2,2,1");	//ext t0,t2,n,1 n:7,6,5,4,3,2,1,0,7,6...
		asm volatile("movn	$v1,$t3,$t0");
	asm volatile("sb	$t1,0($a2)");
	asm volatile("rotr	$t1,$t1,8");
		asm volatile("sll	$v1,$v1,4");
		asm volatile("addu	$v1,$v1,$a1");
	nop();
	asm volatile("sb	$t1,0($a2)");
	asm volatile("rotr	$t1,$t1,8");
	nop();
	nop();
	nop();
	asm volatile("sb	$t1,0($a2)");
			asm volatile("lbu	$t5,0($a0)");//̕R[hǂݍ
		asm volatile("lw	$t1,4($v1)");	//lw t1,n(v1) n:0,4,8,12,0,4...
		asm volatile("sb	$t1,0($a2)");	//hbgŏ̏o
		asm volatile("rotr	$t1,$t1,8");
	asm volatile("and	$v1,$v1,$zero");
	asm volatile("ext	$t0,$t2,1,1");	//ext t0,t2,n,1 n:7,6,5,4,3,2,1,0,7,6...
	asm volatile("movn	$v1,$t3,$t0");
		asm volatile("sb	$t1,0($a2)");
		asm volatile("rotr	$t1,$t1,8");
	asm volatile("sll	$v1,$v1,4");
	asm volatile("addu	$v1,$v1,$a1");
	nop();
		asm volatile("sb	$t1,0($a2)");
		asm volatile("rotr	$t1,$t1,8");
			asm volatile("sll	$t5,$t5,3");
			asm volatile("addu	$t5,$t5,$t4");
	nop();
		asm volatile("sb	$t1,0($a2)");
	nop();
	nop();
	asm volatile("lw	$t1,8($v1)");	//lw t1,n(v1) n:0,4,8,12,0,4...
	asm volatile("sb	$t1,0($a2)");	//hbgŏ̏o
	asm volatile("rotr	$t1,$t1,8");
		asm volatile("and	$v1,$v1,$zero");
		asm volatile("ext	$t0,$t2,0,1");	//ext t0,t2,n,1 n:7,6,5,4,3,2,1,0,7,6...
		asm volatile("movn	$v1,$t3,$t0");
	asm volatile("sb	$t1,0($a2)");
	asm volatile("rotr	$t1,$t1,8");
		asm volatile("sll	$v1,$v1,4");
		asm volatile("addu	$v1,$v1,$a1");
	nop();
	asm volatile("sb	$t1,0($a2)");
	asm volatile("rotr	$t1,$t1,8");
			asm volatile("lbu	$t3,%0($a0)"::"n"(ATTROFFSET));
			asm volatile("addiu	$a0,$a0,1");
	asm volatile("sb	$t1,0($a2)");
		asm volatile("lw	$t1,12($v1)");	//lw t1,n(v1) n:0,4,8,12,0,4...
			asm volatile("lbu	$t2,0($t5)");
		asm volatile("sb	$t1,0($a2)");	//hbgŏ̏o
		asm volatile("rotr	$t1,$t1,8");
	asm volatile("and	$v1,$v1,$zero");
	asm volatile("ext	$t0,$t2,7,1");	//ext t0,t2,n,1 n:7,6,5,4,3,2,1,0,7,6...
	asm volatile("movn	$v1,$t3,$t0");
		asm volatile("sb	$t1,0($a2)");
		asm volatile("rotr	$t1,$t1,8");
	asm volatile("sll	$v1,$v1,4");
	asm volatile("addu	$v1,$v1,$a1");
	nop();
		asm volatile("sb	$t1,0($a2)");
		asm volatile("rotr	$t1,$t1,8");
			asm volatile("addiu	$v0,$v0,-1");//[vJE^
	nop();
	nop();
		asm volatile("sb	$t1,0($a2)");
	asm volatile("lw	$t1,0($v1)");	//lw t1,n(v1) n:0,4,8,12,0,4...
	nop();
			asm volatile("bnez	$v0,label_loop1");


//----------------------------------------------------------------------

	//	LATE=C_BLK;
	asm volatile("addiu	$t1,$zero,%0"::"n"(C_BLK));
	asm volatile("sb	$t1,0($a2)");

	Fontp++;// ̍sցitHgj
	if(Fontp==FontRAM+8){
		TVRAMp+=WIDTH_X;// ̍sցieLXgj
		Fontp=FontRAM;
	}
	if(LineCount==V_SYNC+V_PREEQ+V_LINE){ // 1ʍŌ̕`I
			drawing=0;
			drawcount++;
			TVRAMp=TVRAM;
			Fontp=FontRAM;
	}

asm volatile("label3:");
	mOC1ClearIntFlag();			// OC1荞݃tONA
}

//eLXgʃNA
void clearTVRAM(void)
{
	unsigned int *vp;
	int i;
	vp=(unsigned int *)TVRAM;
	for(i=0;i<WIDTH_X*WIDTH_Y*2/4;i++) *vp++=0;
}

void set_palette(unsigned char n,unsigned char b,unsigned char r,unsigned char g)
{
	// J[pbgݒi5rbgDAAd3.3VA316j
	// n:pbgԍ0?255Ar,g,b:0-255
	// PxY=0.587*G+0.114*B+0.299*R
	// MN=Y+0.4921*(B-Y)*sin+0.8773*(R-Y)*cos
	// o̓f[^S=(N*0.71[v]+0.29[v])/3.3[v]*64*1.3

	int y;
	y=(150*g+29*b+77*r+128)/256;

	ClTable[n*16+ 0]=(4582*y+   0*((int)b-y)+4020*((int)r-y)+1872*256+32768)/65536;//=2*3*0/16
	ClTable[n*16+ 1]=(4582*y+2083*((int)b-y)+1538*((int)r-y)+1872*256+32768)/65536;//=2*3*1/16
	ClTable[n*16+ 2]=(4582*y+1595*((int)b-y)-2843*((int)r-y)+1872*256+32768)/65536;//=2*3*2/16
	ClTable[n*16+ 3]=(4582*y- 863*((int)b-y)-3714*((int)r-y)+1872*256+32768)/65536;//=2*3*3/16
	ClTable[n*16+ 4]=(4582*y-2255*((int)b-y)+   0*((int)r-y)+1872*256+32768)/65536;//=2*3*4/16
	ClTable[n*16+ 5]=(4582*y- 863*((int)b-y)+3714*((int)r-y)+1872*256+32768)/65536;//=2*3*5/16
	ClTable[n*16+ 6]=(4582*y+1595*((int)b-y)+2843*((int)r-y)+1872*256+32768)/65536;//=2*3*6/16
	ClTable[n*16+ 7]=(4582*y+2083*((int)b-y)-1538*((int)r-y)+1872*256+32768)/65536;//=2*3*7/16
	ClTable[n*16+ 8]=(4582*y+   0*((int)b-y)-4020*((int)r-y)+1872*256+32768)/65536;//=2*3*8/16
	ClTable[n*16+ 9]=(4582*y-2083*((int)b-y)-1539*((int)r-y)+1872*256+32768)/65536;//=2*3*9/16
	ClTable[n*16+10]=(4582*y-1595*((int)b-y)+2843*((int)r-y)+1872*256+32768)/65536;//=2*3*10/16
	ClTable[n*16+11]=(4582*y+ 863*((int)b-y)+3714*((int)r-y)+1872*256+32768)/65536;//=2*3*11/16
	ClTable[n*16+12]=(4582*y+2255*((int)b-y)+   0*((int)r-y)+1872*256+32768)/65536;//=2*3*12/16
	ClTable[n*16+13]=(4582*y+ 863*((int)b-y)-3714*((int)r-y)+1872*256+32768)/65536;//=2*3*13/16
	ClTable[n*16+14]=(4582*y-1595*((int)b-y)-2843*((int)r-y)+1872*256+32768)/65536;//=2*3*14/16
	ClTable[n*16+15]=(4582*y-2083*((int)b-y)+1538*((int)r-y)+1872*256+32768)/65536;//=2*3*15/16

}

void start_composite(void)
{
	// ϐݒ
	LineCount=0;				// CJE^[
	drawing=0;
	TVRAMp=TVRAM;
	Fontp=FontRAM;

	PR2 = H_NTSC -1; 			// 63.5usecɐݒ
	T2CONSET=0x8000;			// ^C}2X^[g
}
void stop_composite(void)
{
	T2CONCLR = 0x8000;			// ^C}2~
}

// J[R|Wbgo͏
void init_composite(void)
{
	unsigned int i;
	unsigned int *fontp,*fontramp;

	clearTVRAM();

	//tHg@FontData[]RAMPCG[]ɃRs[
	fontp=(unsigned int *)FontData;
	fontramp=(unsigned int *)FontRAM;
	for(i=0;i<256*8/4;i++) *fontramp++=*fontp++;

	//J[pbg
	for(i=0;i<8;i++){
		set_palette(i,255*(i&1),255*((i>>1)&1),255*(i>>2));
	}
	for(i=0;i<8;i++){
		set_palette(i+8,128*(i&1),128*((i>>1)&1),128*(i>>2));
	}
	for(i=16;i<256;i++){
		set_palette(i,255,255,255);
	}

	// ^C}2̏ݒ,NbN63.5usecA1:1
	T2CON = 0x0000;				// ^C}2~
	mT2SetIntPriority(5);			// 荞݃x5
	mT2ClearIntFlag();
	mT2IntEnable(1);			// ^C}2荞ݗL

	// OC1̊荞ݗL
	mOC1SetIntPriority(5);			// 荞݃x5
	mOC1ClearIntFlag();
	mOC1IntEnable(1);			// OC1荞ݗL

	// OC3̊荞ݗL
	mOC3SetIntPriority(5);			// 荞݃x5
	mOC3ClearIntFlag();
	mOC3IntEnable(1);			// OC3荞ݗL

	OSCCONCLR=0x10; // WAIT߂̓ACh[h
	INTEnableSystemMultiVectoredInt();
	SYSTEMConfig(95000000,SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE); //LbVLiӃNbNɂ͓KpȂj
	BMXCONCLR=0x40;	// RAMANZXEFCg0
	start_composite();
}
